/*
 * @(#)PadGenerator.java    Pzt 19 Nis 2010 14:19:12 EEST
 *
 * Murat iNAN, muratsivas76@gmail.com
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/
package net.dilmerkezi.pad;

import java.io.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.text.*;

import org.xml.sax.*;
import org.xml.sax.helpers.*;

//custom
import net.dilmerkezi.xml.*;
import net.dilmerkezi.lf.*;
import net.dilmerkezi.list.*;


/**
 * Pad Generator
 *
 * @author Murat iNAN, dilmerkezi.net
 */
public final class PadGenerator
           extends JPanel 
        implements ActionListener
{

    /** File selecting tool*/
    final JFileChooser jfc = new JFileChooser ();
    
    /** File selecting tool (txt, html)*/
    final JFileChooser jfcTH = new JFileChooser ();
    
    /** Tabbed pane*/
    final JTabbedPane tabbedpane = new JTabbedPane (/*JTabbedPane.LEFT*/);
    
    /** menubar object*/
    final private JMenuBar mb;
    
    /** License String*/
    private final String LICENSETEXT = License.getLicense ();
    
    /* Report area*/
    private final JTextPane reportArea = getArea ("Reports Of Validating Process:");
    
    private final JTextField cmpNameField = getField ("");
    private final JTextField cmpAdr1Field = getField ("");
    private final JTextField cmpAdr2Field = getField ("");
    private final JTextField cmpcityField = getField ("");
    private final JTextField cmpstateField = getField ("");
    private final JTextField cmpzipField = getField ("");
    private final JTextField cmpcountryField = getField (""); 
    private final JTextField cmpwebField = getField ("http://");    
    
    private final JTextField authorNameField = getField ("");
    private final JTextField authorSurnameField = getField ("");    
    private final JTextField authorMailField = getField ("");
    private final JTextField authorContactNameField = getField ("");
    private final JTextField authorContactSurnameField = getField ("");    
    private final JTextField authorContactMailField = getField ("");    
    
    private final JTextField supportSalesMailField = getField ("");
    private final JTextField supportMailField = getField ("");    
    private final JTextField supportGeneralMailField = getField ("");    
    private final JTextField supportSalesPhoneField = getField ("");
    private final JTextField supportPhoneField = getField ("");    
    private final JTextField supportGeneralPhoneField = getField ("");    
    private final JTextField supportFaxField = getField ("");    

    private final JTextField programNameField = getField_2 ("");
    private final JTextField programVersionField = getField_2 ("");
    private final JComboBox programReleaseBoxM = getBox (Statutes.getMonths ());
    private final JComboBox programReleaseBoxD = getBox (Statutes.getDays ());
    private final JComboBox programReleaseBoxY = getBox (Statutes.getYears ());
    private final JTextField programCostField = getField_2 ("");
    private final JComboBox programCostOtherCodeBox = getBox (Currencies.getCurrencies ());
    private final JTextField programCostOtherField = getField_2 ("");
    private final JComboBox programTypeBox = getBox (Statutes.getTypeStatutes ());
    private final JComboBox programReleaseStatusBox = getBox (Statutes.getReleaseStatutes ());
    private final JComboBox programInstallSupportBox = getBox (Statutes.getInstallStatutes ());
    private final JList programOSSupportBox = getList (Statutes.getOSStatutes ());
    private final JComboBox programLanguageBox = getBox (Languages.getLanguages ());
    private final JTextField programChangeInfoField = getField_2 ("");
    private final JComboBox programSpecificCategoryBox = getBox (MainCategories.getMainCategories ());
    private final JComboBox programCategoryBox = getBox (FullCategories.getFullCategories ());
    private final JTextField programRequirementsField = getField_2 ("");

    private final JTextField fileSizeBytesField = getField ("");
    private final JTextField fileSizeKBField = getField ("");
    private final JTextField fileSizeMBField = getField ("");
    
    private final JComboBox expireHasBox = getBox (Statutes.getYesNo ());
    private final JTextField expireCountField = getField ("");
    private final JTextField expireBasedOnField = getField ("");
    private final JTextField expireOtherInfoField = getField ("");
    private final JComboBox expireDateBoxM = getBox (Statutes.getMonths ());
    private final JComboBox expireDateBoxD = getBox (Statutes.getDays ());
    private final JComboBox expireDateBoxY = getBox (Statutes.getYears ());

    private final JTextField descriptionLanguageField = getField ("English");
    private final JTextField descriptionKeywordsField = getField ("");
    private final JTextField description45Field = getField ("45 chars");
    private final JTextField description80Field = getField ("80 chars");
    private final JTextField description250Field = getField ("250 chars");
    private final JTextField description450Field = getField ("450 chars");
    private final JTextPane description2000Area = getArea ("2000 chars");

    private final JTextField descriptionLanguageFieldES = getField ("Spanish");
    private final JTextField descriptionKeywordsFieldES = getField ("");
    private final JTextField description45FieldES = getField ("45 chars");
    private final JTextField description80FieldES = getField ("80 chars");
    private final JTextField description250FieldES = getField ("250 chars");
    private final JTextField description450FieldES = getField ("450 chars");
    private final JTextPane description2000AreaES = getArea ("2000 chars");

    private final JTextField descriptionLanguageFieldDE = getField ("German");
    private final JTextField descriptionKeywordsFieldDE = getField ("");
    private final JTextField description45FieldDE = getField ("45 chars");
    private final JTextField description80FieldDE = getField ("80 chars");
    private final JTextField description250FieldDE = getField ("250 chars");
    private final JTextField description450FieldDE = getField ("450 chars");
    private final JTextPane description2000AreaDE = getArea ("2000 chars");

    private final JTextField descriptionLanguageFieldDN = getField ("Danish");
    private final JTextField descriptionKeywordsFieldDN = getField ("");
    private final JTextField description45FieldDN = getField ("45 chars");
    private final JTextField description80FieldDN = getField ("80 chars");
    private final JTextField description250FieldDN = getField ("250 chars");
    private final JTextField description450FieldDN = getField ("450 chars");
    private final JTextPane description2000AreaDN = getArea ("2000 chars");

    private final JTextField descriptionLanguageFieldFR = getField ("French");
    private final JTextField descriptionKeywordsFieldFR = getField ("");
    private final JTextField description45FieldFR = getField ("45 chars");
    private final JTextField description80FieldFR = getField ("80 chars");
    private final JTextField description250FieldFR = getField ("250 chars");
    private final JTextField description450FieldFR = getField ("450 chars");
    private final JTextPane description2000AreaFR = getArea ("2000 chars");

    private final JTextField descriptionLanguageFieldPR = getField ("Portuguese");
    private final JTextField descriptionKeywordsFieldPR = getField ("");
    private final JTextField description45FieldPR = getField ("45 chars");
    private final JTextField description80FieldPR = getField ("80 chars");
    private final JTextField description250FieldPR = getField ("250 chars");
    private final JTextField description450FieldPR = getField ("450 chars");
    private final JTextPane description2000AreaPR = getArea ("2000 chars");
    
    private final JTextField descriptionLanguageFieldTR = getField ("Turkish");
    private final JTextField descriptionKeywordsFieldTR = getField ("");
    private final JTextField description45FieldTR = getField ("45 chars");
    private final JTextField description80FieldTR = getField ("80 chars");
    private final JTextField description250FieldTR = getField ("250 chars");
    private final JTextField description450FieldTR = getField ("450 chars");
    private final JTextPane description2000AreaTR = getArea ("2000 chars");
    
    private final JTextComponent [][] twodimcomp =
    {
        {
            descriptionLanguageField,
            descriptionKeywordsField,
            description45Field,
            description80Field,
            description250Field,
            description450Field,
            description2000Area,
        },
        {
            descriptionLanguageFieldES,
            descriptionKeywordsFieldES,
            description45FieldES,
            description80FieldES,
            description250FieldES,
            description450FieldES,
            description2000AreaES
        },
        {
            descriptionLanguageFieldDE,
            descriptionKeywordsFieldDE,
            description45FieldDE,
            description80FieldDE,
            description250FieldDE,
            description450FieldDE,
            description2000AreaDE
         },
         {
            descriptionLanguageFieldDN,
            descriptionKeywordsFieldDN,
            description45FieldDN,
            description80FieldDN,
            description250FieldDN,
            description450FieldDN,
            description2000AreaDN,
        },
        {
            descriptionLanguageFieldFR,
            descriptionKeywordsFieldFR,
            description45FieldFR,
            description80FieldFR,
            description250FieldFR,
            description450FieldFR,
            description2000AreaFR,
        },
        {
            descriptionLanguageFieldPR,
            descriptionKeywordsFieldPR,
            description45FieldPR,
            description80FieldPR,
            description250FieldPR,
            description450FieldPR,
            description2000AreaPR,
        },
        {
            descriptionLanguageFieldTR,
            descriptionKeywordsFieldTR,
            description45FieldTR,
            description80FieldTR,
            description250FieldTR,
            description450FieldTR,
            description2000AreaTR,
        }
    };

    private final JTextField webApplicationInfoURLField = getField ("");
    private final JTextField webApplicationOrderURLField = getField ("");
    private final JTextField webApplicationScreenshotURLField = getField ("");
    private final JTextField webApplicationIconURLField = getField ("");
    private final JTextField webApplicationPadURLField = getField ("");
    private final JTextField webApplicationDownloadPrimaryURLField = getField ("");
    private final JTextField webApplicationDownloadSecondaryURLField = getField ("");
    private final JTextField webApplicationDownloadAdditional_1_URLField = getField ("");    
    private final JTextField webApplicationDownloadAdditional_2_URLField = getField ("");    

    private final JTextPane permissionsDistArea = getArea ("Distribution Permissions");    
    private final JTextPane permissionsLicenceArea = getArea ("Licence");
    
    private final JComboBox affiliatesFormBox = getBox (Statutes.getYesNo ());
    private final JTextField affiliatesVersionField = getField ("1.4");
    private static final String AFURL = "http://www.asp-shareware.org/pad/extensions/Affiliates.htm";
    private final JTextField affiliatesURLField = getField (AFURL);
    private final JTextField affiliatesInfoPageField = getField ("");
    private final JTextField avangateOrderField = getField ("");        
    private final JTextField avangateVendorField = getField ("");        
    private final JTextField avangateProductField = getField ("");            
    private final JTextField avangateCommissionRateField = getField ("");
    private final JTextField regnowOrderField = getField ("");        
    private final JTextField regnowVendorField = getField ("");        
    private final JTextField regnowProductField = getField ("");            
    private final JTextField regnowCommissionRateField = getField ("");
    
    private final JComboBox affiliatesASPFormBox = getBox (Statutes.getYesNo ());
    private final JTextField affiliatesASPMemberField = getField ("N");
    private final JTextField affiliatesASPMemberNumberField = getField ("");
    
    /** Frame*/
    private static JFrame fr;
    
    
    /** text components*/
    private final JComponent [] components =
    {
        cmpNameField, cmpAdr1Field, cmpAdr2Field, cmpcityField,
        cmpstateField, cmpzipField, cmpcountryField, cmpwebField,

        authorNameField, authorSurnameField, authorMailField,
        authorContactNameField, authorContactSurnameField,        
        authorContactMailField,
        
        supportSalesMailField, supportMailField, supportGeneralMailField,        
        supportSalesPhoneField, supportPhoneField, supportGeneralPhoneField,        
        supportFaxField,

        programNameField, programVersionField,
        programReleaseBoxM, programReleaseBoxD, programReleaseBoxY,
        programCostField, programCostOtherCodeBox,
        programCostOtherField, programTypeBox, programReleaseStatusBox,
        programInstallSupportBox, programOSSupportBox,
        programLanguageBox,  programChangeInfoField,
        programSpecificCategoryBox, programCategoryBox,
        programRequirementsField,

        fileSizeBytesField, fileSizeKBField, fileSizeMBField,
        
        expireHasBox, expireCountField,
        expireBasedOnField, expireOtherInfoField,
        expireDateBoxM, expireDateBoxD, expireDateBoxY,

        //descriptionLanguageField,
        descriptionKeywordsField,
        description45Field, description80Field,
        description250Field, description450Field,
        description2000Area,

        webApplicationInfoURLField, webApplicationOrderURLField,
        webApplicationScreenshotURLField, webApplicationIconURLField,
        webApplicationPadURLField, webApplicationDownloadPrimaryURLField,
        webApplicationDownloadSecondaryURLField,
        webApplicationDownloadAdditional_1_URLField,        
        webApplicationDownloadAdditional_2_URLField,

        permissionsDistArea, permissionsLicenceArea,
        
        affiliatesFormBox, affiliatesVersionField,
        affiliatesURLField, affiliatesInfoPageField, affiliatesASPFormBox,
        affiliatesASPMemberField, affiliatesASPMemberNumberField,
        
        avangateOrderField, avangateVendorField, avangateProductField,
        avangateCommissionRateField,
        
        regnowOrderField, regnowVendorField, regnowProductField,
        regnowCommissionRateField
        
    };
    
    /** Components count*/
    private final int componentsLength = components.length;
     
    /** Site icon*/
    private ImageIcon icon = null;
    
    /** Multi lengual?*/
    private boolean multilengual = true;
    
    /** XMLReader object*/
    private XMLReader xmlreader;
    
    /** Custom Content handler*/
    final private ContentHandler handler = 
        new MyContentHandler (components, componentsLength, twodimcomp, twodimcomp.length);

    /** Singleton constructor*/
    private PadGenerator ()
    {
        super (new BorderLayout ());
        
        
        descriptionLanguageField.setEditable (false);
        descriptionLanguageFieldES.setEditable (false);
        descriptionLanguageFieldDE.setEditable (false);
        descriptionLanguageFieldDN.setEditable (false);
        descriptionLanguageFieldPR.setEditable (false);
        descriptionLanguageFieldFR.setEditable (false);
        descriptionLanguageFieldTR.setEditable (false);
        
        final String javers = System.getProperty ("java.version");
        try
        {
            //Note that this maybe connot run under 1.4
            if (javers.compareTo ("1.4") <= 0)
            {
                 xmlreader = XMLReaderFactory.createXMLReader 
                  ("com.sun.org.apache.xerces.internal.parsers.SAXParser");
                 System.out.println ("XMLReader: "+xmlreader.toString ()+"\n");
                 xmlreader.setContentHandler (handler);
            }
            else
            {//This runs under 1.5 and 1.6 properly
                xmlreader = XMLReaderFactory.createXMLReader ();
                System.out.println ("XMLReader: "+xmlreader.toString ()+"\n");
                xmlreader.setContentHandler (handler);
            }
        }
        catch (Exception e)
        {
            e.printStackTrace ();
            xmlreader = null;
        }
        
        setNames ();
        resetBoxes ();
        
        jfc.setCurrentDirectory (new File ("."));
        jfc.addChoosableFileFilter (new Filter ());
        jfc.setAcceptAllFileFilterUsed (false);

        jfcTH.setCurrentDirectory (new File ("."));
        jfcTH.addChoosableFileFilter (new FilterTH ());
        jfcTH.setAcceptAllFileFilterUsed (false);

        mb = new JMenuBar ();
        JMenu fileMenu = getMenu ("File");
        fileMenu.setMnemonic (KeyEvent.VK_ALT);
        mb.add (fileMenu);

        JMenuItem validateItem = getItem ("Validate");
        validateItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread th = new Thread ()
                {
                    public void run ()
                    {
                        try
                        {
                            if (xmlvalidate ())
                            {
                                JOptionPane.showMessageDialog (mb, "Please Look At Report Tab");
                            }
                            return;
                        }
                        catch (Exception e)
                        {
                            JOptionPane.showMessageDialog (mb,
                                "Un Error Occurred While ValidatingFields!",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                th.start ();
            }
        });
        fileMenu.add (validateItem);
        
        fileMenu.addSeparator ();
        
        JMenuItem generateItem = getItem ("Generate MultiLengual XML");
        generateItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread th = new Thread ()
                {
                    public void run ()
                    {
                        try
                        {
                            multilengual = true;
                            if (generate ())
                            {
                                JOptionPane.showMessageDialog (mb, "Generated File.");
                            }
                            return;
                        }
                        catch (Exception e)
                        {
                            JOptionPane.showMessageDialog (mb,
                                "Un Error Occurred While Generating PAD File!",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                th.start ();
            }
        });
        fileMenu.add (generateItem);
        
        JMenuItem generateENItem = getItem ("Generate English XML");
        generateENItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread th = new Thread ()
                {
                    public void run ()
                    {
                        try
                        {
                            multilengual = false;
                            if (generate ())
                            {
                                JOptionPane.showMessageDialog (mb, "Generated File.");
                            }
                            return;
                        }
                        catch (Exception e)
                        {
                            JOptionPane.showMessageDialog (mb,
                                "Un Error Occurred While Generating PAD File!",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                th.start ();
            }
        });
        fileMenu.add (generateENItem);
 
        
        JMenuItem generateTXTItem = getItem ("Generate TXT");
        generateTXTItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread th = new Thread ()
                {
                    public void run ()
                    {
                        try
                        {
                            if (generateTXT ())
                            {
                                JOptionPane.showMessageDialog (mb, "Generated File.");
                            }
                            return;
                        }
                        catch (Exception e)
                        {
                            JOptionPane.showMessageDialog (mb,
                                "Un Error Occurred While Generating TXT File!",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                th.start ();
            }
        });
        fileMenu.add (generateTXTItem);
        
        JMenuItem generateHTMLItem = getItem ("Generate HTML");
        generateHTMLItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread th = new Thread ()
                {
                    public void run ()
                    {
                        try
                        {
                            if (generateHTML ())
                            {
                                JOptionPane.showMessageDialog (mb, "Generated File.");
                            }
                            return;
                        }
                        catch (Exception e)
                        {
                            JOptionPane.showMessageDialog (mb,
                                "Un Error Occurred While Generating HTML File!",
                                "Error",
                                JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                th.start ();
            }
        });
        fileMenu.add (generateHTMLItem);
        
        fileMenu.addSeparator ();
        
        JMenuItem exitItem = getItem ("Exit");
        exitItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                System.exit (0);
            }
        });
        fileMenu.add (exitItem);
        
        JMenu lookMenu = getMenu ("Look");
        mb.add (lookMenu);
        
        JMenuItem readItem = getItem ("Read");
        readItem.addActionListener (this);
        lookMenu.add (readItem);
        
        lookMenu.addSeparator ();
        
        JMenuItem readSingleItem = getItem ("Read Single");
        readSingleItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Thread t = new Thread ()
                {
                    public void run ()
                    {
                        if (readSingle ())
                        {
                            JOptionPane.showMessageDialog (mb, "Please look at reports tab.");
                            return;
                        }
                        else
                        {
                            JOptionPane.showMessageDialog (mb, 
                               "Un Error Ocurred When The File Is Parsing!", 
                               "Error", JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                    }
                };
                t.start ();
                
            }
        });
        lookMenu.add (readSingleItem);
        
        JMenu resMenu = getMenu ("Revise");
        mb.add (resMenu);
        
        JMenuItem resetItem = getItem ("Reset");
        resetItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                reset ();
                resetBoxes ();
            }
        });
        resMenu.add (resetItem);
        
        JMenuItem clsItem = getItem ("Clear Reports");
        clsItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                reportArea.setText ("");
            }
        });
        resMenu.add (clsItem);        
        
        resMenu.addSeparator ();
        
        JMenuItem licItem = getItem ("License");
        licItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                Runnable r = new Runnable ()
                {
                    public void run ()
                    {
                        JOptionPane.showMessageDialog (mb, LICENSETEXT);
                        return;
                    }
                };
                javax.swing.SwingUtilities.invokeLater (r);    
            }
        });
        resMenu.add (licItem);
        
        resMenu.addSeparator ();
        
        JMenuItem visitItem = getItem ("Visit Us");
        visitItem.addActionListener (new ActionListener ()
        {
            public void actionPerformed (ActionEvent evt)
            {
                visit ();
            }
        });
        resMenu.add (visitItem);
        
        //if (javers.compareTo ("1.6") >= 0)
        //{
            JMenu lfMenu = getMenu ("LF");
            mb.add (lfMenu);
        
            final JMenuItem metal_1_Item = getItem ("Metal 1");//internal using must be final
            metal_1_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme1 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_1_Item);
            
            final JMenuItem metal_2_Item = getItem ("Metal 2");//internal using must be final
            metal_2_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme2 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_2_Item);
            
            final JMenuItem metal_3_Item = getItem ("Metal 3");//internal using must be final
            metal_3_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme3 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_3_Item);
            
            final JMenuItem metal_4_Item = getItem ("Metal 4");//internal using must be final
            metal_4_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme4 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_4_Item);
            
            final JMenuItem metal_5_Item = getItem ("Metal 5");//internal using must be final
            metal_5_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme5 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_5_Item);
            
            final JMenuItem metal_6_Item = getItem ("Metal 6");//internal using must be final
            metal_6_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme6 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_6_Item);
            
            final JMenuItem metal_7_Item = getItem ("Metal 7");//internal using must be final
            metal_7_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme7 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_7_Item);
            
            final JMenuItem metal_8_Item = getItem ("Metal 8");//internal using must be final
            metal_8_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme8 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_8_Item);
            
            final JMenuItem metal_9_Item = getItem ("Metal 9");//internal using must be final
            metal_9_Item.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        javax.swing.plaf.metal.MetalLookAndFeel.setCurrentTheme (
                            new Theme9 ());
                        UIManager.setLookAndFeel (
                            new javax.swing.plaf.metal.MetalLookAndFeel ());
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (metal_9_Item);
            
            lfMenu.addSeparator ();
            
            final JMenuItem nimbusItem = getItem ("Nimbus");//internal using must be final
            nimbusItem.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        if (javers.compareTo ("1.6") < 0) return;
                        UIManager.setLookAndFeel 
                            ("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (nimbusItem);
            
            lfMenu.addSeparator ();
            
            final JMenuItem motifItem = getItem ("Motif");//internal using must be final
            motifItem.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        UIManager.setLookAndFeel 
                            ("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (motifItem);
            
            lfMenu.addSeparator ();
            final JMenuItem windowsItem = getItem ("Windows");//internal using must be final
            windowsItem.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        if ((System.getProperty ("os.name")).indexOf ("Windows") < 0)
                            return;
                        UIManager.setLookAndFeel 
                            ("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (windowsItem);
            
            lfMenu.addSeparator ();
            final JMenuItem gtkItem = getItem ("GTK");//internal using must be final
            gtkItem.addActionListener (new ActionListener ()
            {
                public void actionPerformed (ActionEvent evt)
                {
                    try
                    {
                        if ((System.getProperty ("os.name")).indexOf ("Linux") < 0)
                            return;
                        UIManager.setLookAndFeel 
                            ("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
                        javax.swing.SwingUtilities.updateComponentTreeUI (fr);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfc);
                        javax.swing.SwingUtilities.updateComponentTreeUI (jfcTH);
                    }
                    catch (Exception e)
                    {}
                }
            });
            lfMenu.add (gtkItem);
        //}
        
        JPanel spanel = new JPanel (new BorderLayout ());
        spanel.setPreferredSize (new Dimension (600, 25));
        
        spanel.add ("Center", mb);
        
        add ("North", spanel);    
        
        try
        {
            icon = new ImageIcon (
             (Toolkit.getDefaultToolkit ()).createImage (IconBytes.getIconBytes ())
            );
        }// try ; alamaz ama catch alabilir
        catch (Exception e)
        { 
            icon = null;
        }; //; alabilir
        
        tabbedpane.setFont (new Font ("Serif", 0x0, 0xC));
//        tabbedpane.setForeground (Color.blue);
        
        JPanel cpanel = new JPanel (new BorderLayout ());

        JPanel companyPanel = getPanel ("Company");
        tabbedpane.addTab ("Company", companyPanel);
        
        companyPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 7));
        
        JLabel cmpNameLabel = getLabel ("Name: ", JLabel.LEFT);
        companyPanel.add (cmpNameLabel);
        companyPanel.add (cmpNameField);
        
        JLabel cmpAdr1Label = getLabel ("Address 1: ", JLabel.LEFT);
        companyPanel.add (cmpAdr1Label);
        companyPanel.add (cmpAdr1Field);
        
        JLabel cmpAdr2Label = getLabel ("Address 2: ", JLabel.LEFT);
        companyPanel.add (cmpAdr2Label);
        companyPanel.add (cmpAdr2Field);
        
        JLabel cmpcityLabel = getLabel ("City: ", JLabel.LEFT);
        companyPanel.add (cmpcityLabel);
        companyPanel.add (cmpcityField);
        
        JLabel cmpstateLabel = getLabel ("State: ", JLabel.LEFT);
        companyPanel.add (cmpstateLabel);
        companyPanel.add (cmpstateField);

        JLabel cmpzipLabel = getLabel ("Zip Code: ", JLabel.LEFT);
        companyPanel.add (cmpzipLabel);
        companyPanel.add (cmpzipField);
        
        JLabel cmpcountryLabel = getLabel ("Country: ", JLabel.LEFT);
        companyPanel.add (cmpcountryLabel);
        companyPanel.add (cmpcountryField);
        
        JLabel cmpwebLabel = getLabel ("URL: ", JLabel.LEFT);
        companyPanel.add (cmpwebLabel);
        companyPanel.add (cmpwebField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 115));
            companyPanel.add (iconPanel);
        }
        
        JPanel authorPanel = getPanel ("Author");
        authorPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 9));
        tabbedpane.addTab ("Author", authorPanel);
        
        JLabel authorNameLabel = getLabel ("Name: ", JLabel.LEFT);
        authorPanel.add (authorNameLabel);
        authorPanel.add (authorNameField);
        
        JLabel authorSurnameLabel = getLabel ("Surname: ", JLabel.LEFT);
        authorPanel.add (authorSurnameLabel);
        authorPanel.add (authorSurnameField);
        
        JLabel authorMailLabel = getLabel ("E-Mail: ", JLabel.LEFT);
        authorPanel.add (authorMailLabel);
        authorPanel.add (authorMailField);
        
        JLabel authorContactNameLabel = getLabel ("Contact Name: ", JLabel.LEFT);
        authorPanel.add (authorContactNameLabel);
        authorPanel.add (authorContactNameField);
                
        JLabel authorContactSurnameLabel = getLabel ("Contact Surname: ", JLabel.LEFT);
        authorPanel.add (authorContactSurnameLabel);        
        authorPanel.add (authorContactSurnameField);
        
        JLabel authorContactMailLabel = getLabel ("Contact E-Mail: ", JLabel.LEFT);
        authorPanel.add (authorContactMailLabel);
        authorPanel.add (authorContactMailField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 155));
            authorPanel.add (iconPanel);
        }

        /////////////
        JPanel supportPanel = getPanel ("Support");
        supportPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 9));
        tabbedpane.addTab ("Support", supportPanel); 
        
        JLabel supportSalesMailLabel = getLabel ("Sales E-Mail: ", JLabel.LEFT);
        supportPanel.add (supportSalesMailLabel);
        supportPanel.add (supportSalesMailField);
        
        JLabel supportMailLabel = getLabel ("E-Mail: ", JLabel.LEFT);
        supportPanel.add (supportMailLabel);
        supportPanel.add (supportMailField);
        
        JLabel supportGeneralMailLabel = getLabel ("General E-Mail: ", JLabel.LEFT);
        supportPanel.add (supportGeneralMailLabel);
        supportPanel.add (supportGeneralMailField);
        
        JLabel supportSalesPhoneLabel = getLabel ("Sales Phone: ", JLabel.LEFT);
        supportPanel.add (supportSalesPhoneLabel);
        supportPanel.add (supportSalesPhoneField);
        
        JLabel supportPhoneLabel = getLabel ("Phone: ", JLabel.LEFT);
        supportPanel.add (supportPhoneLabel);
        supportPanel.add (supportPhoneField);
        
        JLabel supportGeneralPhoneLabel = getLabel ("General Phone: ", JLabel.LEFT);
        supportPanel.add (supportGeneralPhoneLabel);
        supportPanel.add (supportGeneralPhoneField);
        
        JLabel supportFaxLabel = getLabel ("Fax: ", JLabel.LEFT);
        supportPanel.add (supportFaxLabel);
        supportPanel.add (supportFaxField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 135));
            supportPanel.add (iconPanel);
        }
        /////
        
        JPanel programPanel = getPanel ("Program");
        programPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("Program", programPanel);
        
        JLabel programNameLabel = getLabel_2 ("Name: ", JLabel.LEFT);
        programPanel.add (programNameLabel);
        programPanel.add (programNameField);
        
        JLabel programVersionLabel = getLabel_2 ("Version: ", JLabel.LEFT);
        programPanel.add (programVersionLabel);
        programPanel.add (programVersionField);
        
        JLabel programReleaseLabelM = getLabel_2 ("Release M: ", JLabel.LEFT);
        programReleaseLabelM.setPreferredSize (new Dimension (100, 25));
        programPanel.add (programReleaseLabelM);
        programReleaseBoxM.setPreferredSize (new Dimension (90, 25));
        programPanel.add (programReleaseBoxM);
        
        JLabel programReleaseLabelD = getLabel_2 ("Release D: ", JLabel.LEFT);
        programReleaseLabelD.setPreferredSize (new Dimension (90, 25));
        programPanel.add (programReleaseLabelD);
        programReleaseBoxD.setPreferredSize (new Dimension (90, 25));
        programPanel.add (programReleaseBoxD);
        
        JLabel programReleaseLabelY = getLabel_2 ("Release Y: ", JLabel.LEFT);
        programReleaseLabelY.setPreferredSize (new Dimension (90, 25));
        programPanel.add (programReleaseLabelY);
        programReleaseBoxY.setPreferredSize (new Dimension (90, 25));
        programPanel.add (programReleaseBoxY);
        
        JLabel programCostLabel = getLabel_2 ("Cost: ", JLabel.LEFT);
        programPanel.add (programCostLabel);
        programPanel.add (programCostField);
        
        JLabel programCostOtherCodeLabel = getLabel_2 ("Other Cost Value: ", JLabel.LEFT);
        programPanel.add (programCostOtherCodeLabel);
        programPanel.add (programCostOtherCodeBox); 
        
        JLabel programCostOtherLabel = getLabel_2 ("Other Cost: ", JLabel.LEFT);
        programPanel.add (programCostOtherLabel);        
        programPanel.add (programCostOtherField);
        
        JLabel programTypeLabel = getLabel_2 ("Type: ", JLabel.LEFT);
        programPanel.add (programTypeLabel);        
        programPanel.add (programTypeBox);        
    
        JLabel programReleaseStatusLabel = getLabel_2 ("Status: ", JLabel.LEFT);
        programPanel.add (programReleaseStatusLabel);
        programPanel.add (programReleaseStatusBox);
        
        JLabel programInstallSupportLabel = getLabel_2 ("Install Support: ", JLabel.LEFT);
        programPanel.add (programInstallSupportLabel);
        programPanel.add (programInstallSupportBox);
        
        JLabel programOSSupportLabel = getLabel_2 ("OS Support: ", JLabel.LEFT);
        programPanel.add (programOSSupportLabel);
        
        JScrollPane osjsp= new JScrollPane (programOSSupportBox);
        osjsp.setPreferredSize (new Dimension (460, 40));
        programPanel.add (osjsp);
        
        JLabel programLanguageLabel = getLabel_2 ("Language: ", JLabel.LEFT);
        programPanel.add (programLanguageLabel);        
        programPanel.add (programLanguageBox);
        
        JLabel programChangeInfoLabel = getLabel_2 ("Change Info: ", JLabel.LEFT);
        programPanel.add (programChangeInfoLabel);
        programPanel.add (programChangeInfoField);
        
        JLabel programSpecificCategoryLabel = getLabel_2 ("Specific Category: ", JLabel.LEFT);
        programPanel.add (programSpecificCategoryLabel);
        programPanel.add (programSpecificCategoryBox);
        
        JLabel programCategoryLabel = getLabel_2 ("Category: ", JLabel.LEFT);
        programPanel.add (programCategoryLabel);        
        programPanel.add (programCategoryBox);
        
        JLabel programRequirementsLabel = getLabel_2 ("Requirements: ", JLabel.LEFT);
        programPanel.add (programRequirementsLabel);
        programPanel.add (programRequirementsField);
        ///////
        
        JPanel filePanel = getPanel ("File");
        filePanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 10));
        tabbedpane.addTab ("File", filePanel);
        
        JLabel fileSizeBytesLabel = getLabel ("Size Bytes: ", JLabel.LEFT);
        filePanel.add (fileSizeBytesLabel);
        filePanel.add (fileSizeBytesField);
        
        JLabel fileSizeKBLabel = getLabel ("Size KB: ", JLabel.LEFT);
        filePanel.add (fileSizeKBLabel);
        filePanel.add (fileSizeKBField);
        
        JLabel fileSizeMBLabel = getLabel ("Size MB: ", JLabel.LEFT);
        filePanel.add (fileSizeMBLabel);
        filePanel.add (fileSizeMBField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 250));
            filePanel.add (iconPanel);
        }
        ////////
        
        JPanel expirePanel = getPanel ("Expiration");
        expirePanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 10));
        tabbedpane.addTab ("Expiration", expirePanel);
        
        JLabel expireHasLabel = getLabel ("Has Expire: ", JLabel.LEFT);
        expirePanel.add (expireHasLabel);
        expirePanel.add (expireHasBox);
        
        JLabel expireCountLabel = getLabel ("Expire Count: ", JLabel.LEFT);
        expirePanel.add (expireCountLabel);
        expirePanel.add (expireCountField);
        
        JLabel expireBasedOnLabel = getLabel ("Expire Based On: ", JLabel.LEFT);
        expirePanel.add (expireBasedOnLabel);
        expirePanel.add (expireBasedOnField);
        
        JLabel expireOtherInfoLabel = getLabel ("Expire Other Info: ", JLabel.LEFT);
        expirePanel.add (expireOtherInfoLabel);
        expirePanel.add (expireOtherInfoField);
        
        JLabel expireDateLabelM = getLabel ("Expire M: ", JLabel.LEFT);
        expireDateLabelM.setPreferredSize (new Dimension (100, 25));
        expirePanel.add (expireDateLabelM);
        expireDateBoxM.setPreferredSize (new Dimension (90, 25));
        expirePanel.add (expireDateBoxM);
        
        JLabel expireDateLabelD = getLabel ("Expire D: ", JLabel.LEFT);
        expireDateLabelD.setPreferredSize (new Dimension (90, 25));
        expirePanel.add (expireDateLabelD);
        expireDateBoxD.setPreferredSize (new Dimension (90, 25));
        expirePanel.add (expireDateBoxD);
        
        JLabel expireDateLabelY = getLabel ("Expire Y: ", JLabel.LEFT);
        expireDateLabelY.setPreferredSize (new Dimension (90, 25));
        expirePanel.add (expireDateLabelY);
        expireDateBoxY.setPreferredSize (new Dimension (90, 25));
        expirePanel.add (expireDateBoxY);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 185));
            expirePanel.add (iconPanel);
        }
        ////////////
        
        JPanel descriptionPanel = getPanel ("Description");
        descriptionPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("Description", descriptionPanel);
        
        JLabel descriptionLanguageLabel = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanel.add (descriptionLanguageLabel);
        descriptionPanel.add (descriptionLanguageField);
        
        JLabel descriptionKeywordsLabel = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanel.add (descriptionKeywordsLabel);
        descriptionPanel.add (descriptionKeywordsField);
        
        JLabel description45Label = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanel.add (description45Label);
        descriptionPanel.add (description45Field);
        
        JLabel description80Label = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanel.add (description80Label);
        descriptionPanel.add (description80Field);
        
        JLabel description250Label = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanel.add (description250Label);
        descriptionPanel.add (description250Field);
        
        JLabel description450Label = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanel.add (description450Label);
        descriptionPanel.add (description450Field);
        
        JLabel description2000Label = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanel.add (description2000Label);
                
        JScrollPane description2000jsp= new JScrollPane ();
        description2000jsp.setPreferredSize (new Dimension (460, 225));
        JViewport p2000 = description2000jsp.getViewport ();
        p2000.add (description2000Area);
        descriptionPanel.add (description2000jsp);
        //////////
        JPanel descriptionPanelES = getPanel ("ES Desc");
        descriptionPanelES.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("ES Desc", descriptionPanelES);
        
        JLabel descriptionLanguageLabelES = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelES.add (descriptionLanguageLabelES);
        descriptionPanelES.add (descriptionLanguageFieldES);
        
        JLabel descriptionKeywordsLabelES = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelES.add (descriptionKeywordsLabelES);
        descriptionPanelES.add (descriptionKeywordsFieldES);
        
        JLabel description45LabelES = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelES.add (description45LabelES);
        descriptionPanelES.add (description45FieldES);
        
        JLabel description80LabelES = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelES.add (description80LabelES);
        descriptionPanelES.add (description80FieldES);
        
        JLabel description250LabelES = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelES.add (description250LabelES);
        descriptionPanelES.add (description250FieldES);
        
        JLabel description450LabelES = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelES.add (description450LabelES);
        descriptionPanelES.add (description450FieldES);
        
        JLabel description2000LabelES = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelES.add (description2000LabelES);
                
        JScrollPane description2000jspES= new JScrollPane ();
        description2000jspES.setPreferredSize (new Dimension (460, 225));
        JViewport p2000ES = description2000jspES.getViewport ();
        p2000ES.add (description2000AreaES);
        descriptionPanelES.add (description2000jspES);
        ////////////
        JPanel descriptionPanelDE = getPanel ("DE Desc");
        descriptionPanelDE.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("DE Desc", descriptionPanelDE);
        
        JLabel descriptionLanguageLabelDE = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelDE.add (descriptionLanguageLabelDE);
        descriptionPanelDE.add (descriptionLanguageFieldDE);
        
        JLabel descriptionKeywordsLabelDE = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelDE.add (descriptionKeywordsLabelDE);
        descriptionPanelDE.add (descriptionKeywordsFieldDE);
        
        JLabel description45LabelDE = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelDE.add (description45LabelDE);
        descriptionPanelDE.add (description45FieldDE);
        
        JLabel description80LabelDE = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelDE.add (description80LabelDE);
        descriptionPanelDE.add (description80FieldDE);
        
        JLabel description250LabelDE = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelDE.add (description250LabelDE);
        descriptionPanelDE.add (description250FieldDE);
        
        JLabel description450LabelDE = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelDE.add (description450LabelDE);
        descriptionPanelDE.add (description450FieldDE);
        
        JLabel description2000LabelDE = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelDE.add (description2000LabelDE);
                
        JScrollPane description2000jspDE= new JScrollPane ();
        description2000jspDE.setPreferredSize (new Dimension (460, 225));
        JViewport p2000DE = description2000jspDE.getViewport ();
        p2000DE.add (description2000AreaDE);
        descriptionPanelDE.add (description2000jspDE);
        //////////////
        JPanel descriptionPanelDN = getPanel ("DN Desc");
        descriptionPanelDN.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("DN Desc", descriptionPanelDN);
        
        JLabel descriptionLanguageLabelDN = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelDN.add (descriptionLanguageLabelDN);
        descriptionPanelDN.add (descriptionLanguageFieldDN);
        
        JLabel descriptionKeywordsLabelDN = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelDN.add (descriptionKeywordsLabelDN);
        descriptionPanelDN.add (descriptionKeywordsFieldDN);
        
        JLabel description45LabelDN = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelDN.add (description45LabelDN);
        descriptionPanelDN.add (description45FieldDN);
        
        JLabel description80LabelDN = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelDN.add (description80LabelDN);
        descriptionPanelDN.add (description80FieldDN);
        
        JLabel description250LabelDN = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelDN.add (description250LabelDN);
        descriptionPanelDN.add (description250FieldDN);
        
        JLabel description450LabelDN = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelDN.add (description450LabelDN);
        descriptionPanelDN.add (description450FieldDN);
        
        JLabel description2000LabelDN = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelDN.add (description2000LabelDN);
                
        JScrollPane description2000jspDN= new JScrollPane ();
        description2000jspDN.setPreferredSize (new Dimension (460, 225));
        JViewport p2000DN = description2000jspDN.getViewport ();
        p2000DN.add (description2000AreaDN);
        descriptionPanelDN.add (description2000jspDN);
        ////////////
        JPanel descriptionPanelPR = getPanel ("PR Desc");
        descriptionPanelPR.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("PR Desc", descriptionPanelPR);
        
        JLabel descriptionLanguageLabelPR = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelPR.add (descriptionLanguageLabelPR);
        descriptionPanelPR.add (descriptionLanguageFieldPR);
        
        JLabel descriptionKeywordsLabelPR = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelPR.add (descriptionKeywordsLabelPR);
        descriptionPanelPR.add (descriptionKeywordsFieldPR);
        
        JLabel description45LabelPR = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelPR.add (description45LabelPR);
        descriptionPanelPR.add (description45FieldPR);
        
        JLabel description80LabelPR = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelPR.add (description80LabelPR);
        descriptionPanelPR.add (description80FieldPR);
        
        JLabel description250LabelPR = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelPR.add (description250LabelPR);
        descriptionPanelPR.add (description250FieldPR);
        
        JLabel description450LabelPR = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelPR.add (description450LabelPR);
        descriptionPanelPR.add (description450FieldPR);
        
        JLabel description2000LabelPR = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelPR.add (description2000LabelPR);
                
        JScrollPane description2000jspPR= new JScrollPane ();
        description2000jspPR.setPreferredSize (new Dimension (460, 225));
        JViewport p2000PR = description2000jspPR.getViewport ();
        p2000PR.add (description2000AreaPR);
        descriptionPanelPR.add (description2000jspPR);
        ///////////
        JPanel descriptionPanelFR = getPanel ("FR Desc");
        descriptionPanelFR.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("FR Desc", descriptionPanelFR);
        
        JLabel descriptionLanguageLabelFR = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelFR.add (descriptionLanguageLabelFR);
        descriptionPanelFR.add (descriptionLanguageFieldFR);
        
        JLabel descriptionKeywordsLabelFR = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelFR.add (descriptionKeywordsLabelFR);
        descriptionPanelFR.add (descriptionKeywordsFieldFR);
        
        JLabel description45LabelFR = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelFR.add (description45LabelFR);
        descriptionPanelFR.add (description45FieldFR);
        
        JLabel description80LabelFR = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelFR.add (description80LabelFR);
        descriptionPanelFR.add (description80FieldFR);
        
        JLabel description250LabelFR = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelFR.add (description250LabelFR);
        descriptionPanelFR.add (description250FieldFR);
        
        JLabel description450LabelFR = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelFR.add (description450LabelFR);
        descriptionPanelFR.add (description450FieldFR);
        
        JLabel description2000LabelFR = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelFR.add (description2000LabelFR);
                
        JScrollPane description2000jspFR= new JScrollPane ();
        description2000jspFR.setPreferredSize (new Dimension (460, 225));
        JViewport p2000FR = description2000jspFR.getViewport ();
        p2000FR.add (description2000AreaFR);
        descriptionPanelFR.add (description2000jspFR);
        //////////////
        JPanel descriptionPanelTR = getPanel ("TR Desc");
        descriptionPanelTR.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 1));
        tabbedpane.addTab ("TR Desc", descriptionPanelTR);
        
        JLabel descriptionLanguageLabelTR = getLabel ("Language: ", JLabel.LEFT);
        descriptionPanelTR.add (descriptionLanguageLabelTR);
        descriptionPanelTR.add (descriptionLanguageFieldTR);
        
        JLabel descriptionKeywordsLabelTR = getLabel ("Keywords: ", JLabel.LEFT);
        descriptionPanelTR.add (descriptionKeywordsLabelTR);
        descriptionPanelTR.add (descriptionKeywordsFieldTR);
        
        JLabel description45LabelTR = getLabel ("Desc_45: ", JLabel.LEFT);
        descriptionPanelTR.add (description45LabelTR);
        descriptionPanelTR.add (description45FieldTR);
        
        JLabel description80LabelTR = getLabel ("Desc_80: ", JLabel.LEFT);
        descriptionPanelTR.add (description80LabelTR);
        descriptionPanelTR.add (description80FieldTR);
        
        JLabel description250LabelTR = getLabel ("Desc_250: ", JLabel.LEFT);
        descriptionPanelTR.add (description250LabelTR);
        descriptionPanelTR.add (description250FieldTR);
        
        JLabel description450LabelTR = getLabel ("Desc_450: ", JLabel.LEFT);
        descriptionPanelTR.add (description450LabelTR);
        descriptionPanelTR.add (description450FieldTR);
        
        JLabel description2000LabelTR = getLabel ("Desc_2000: ", JLabel.LEFT);
        descriptionPanelTR.add (description2000LabelTR);
                
        JScrollPane description2000jspTR= new JScrollPane ();
        description2000jspTR.setPreferredSize (new Dimension (460, 225));
        JViewport p2000TR = description2000jspTR.getViewport ();
        p2000TR.add (description2000AreaTR);
        descriptionPanelTR.add (description2000jspTR);
        ////////////
        
        JPanel webInfoPanel = getPanel ("Application Web Info");
        webInfoPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 5));
        tabbedpane.addTab ("Web Info", webInfoPanel); 

        JLabel webApplicationInfoURLLabel = getLabel ("Info URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationInfoURLLabel);
        webInfoPanel.add (webApplicationInfoURLField);
        
        JLabel webApplicationOrderURLLabel = getLabel ("Order URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationOrderURLLabel);
        webInfoPanel.add (webApplicationOrderURLField);
        
        JLabel webApplicationScreenshotURLLabel = getLabel ("Screenshot URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationScreenshotURLLabel);
        webInfoPanel.add (webApplicationScreenshotURLField);
        
        JLabel webApplicationIconURLLabel = getLabel ("Icon URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationIconURLLabel);
        webInfoPanel.add (webApplicationIconURLField);
        
        JLabel webApplicationPadURLLabel = getLabel ("PAD URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationPadURLLabel);
        webInfoPanel.add (webApplicationPadURLField);
        
        JLabel webApplicationDownloadPrimaryURLLabel = getLabel ("1th Download  URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationDownloadPrimaryURLLabel);
        webInfoPanel.add (webApplicationDownloadPrimaryURLField);
        
        JLabel webApplicationDownloadSecondaryURLLabel = getLabel ("2nd Download URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationDownloadSecondaryURLLabel);
        webInfoPanel.add (webApplicationDownloadSecondaryURLField);
        
        JLabel webApplicationDownloadAdditional_1_URLLabel = getLabel ("Download+ URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationDownloadAdditional_1_URLLabel);
        webInfoPanel.add (webApplicationDownloadAdditional_1_URLField);
        
        JLabel webApplicationDownloadAdditional_2_URLLabel = getLabel ("Download++ URL:", JLabel.LEFT);
        webInfoPanel.add (webApplicationDownloadAdditional_2_URLLabel);
        webInfoPanel.add (webApplicationDownloadAdditional_2_URLField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 105));
            webInfoPanel.add (iconPanel);
        }
        
        ///////////////////
        
        JPanel permissionPanel = getPanel ("Permissions");
        permissionPanel.setLayout (new GridLayout (2, 0, 0, 3));
        tabbedpane.addTab ("Perms", permissionPanel);
        
        permissionPanel.add (permissionsDistArea);  
        permissionPanel.add (permissionsLicenceArea);
        /////////////
        
        JPanel affiliatesPanel = getPanel ("Affiliates");
        affiliatesPanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 5));
        tabbedpane.addTab ("Affiliates", affiliatesPanel);
        
        JLabel affiliatesFormLabel = getLabel ("Form: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesFormLabel);
        affiliatesPanel.add (affiliatesFormBox);
        
        JLabel affiliatesVersionLabel = getLabel ("Version: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesVersionLabel);
        affiliatesPanel.add (affiliatesVersionField);
        
        JLabel affiliatesURLLabel = getLabel ("URL: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesURLLabel);
        affiliatesPanel.add (affiliatesURLField);
        
        JLabel affiliatesInfoPageLabel = getLabel ("Info Page: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesInfoPageLabel);
        affiliatesPanel.add (affiliatesInfoPageField);        
        
        JLabel affiliatesASPFormLabel = getLabel ("ASP: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesASPFormLabel);
        affiliatesPanel.add (affiliatesASPFormBox);
        
        JLabel affiliatesASPMemberLabel = getLabel ("ASP Member Name: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesASPMemberLabel);
        affiliatesPanel.add (affiliatesASPMemberField);
        
        JLabel affiliatesASPMemberNumberLabel = getLabel ("ASP Member ID: ", JLabel.LEFT);
        affiliatesPanel.add (affiliatesASPMemberNumberLabel);
        affiliatesPanel.add (affiliatesASPMemberNumberField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 160));
            affiliatesPanel.add (iconPanel);
        }
        ///////////
        JPanel avangatePanel = getPanel ("Avangate");
        avangatePanel.setLayout (new FlowLayout (FlowLayout.LEFT, 1, 9));
        tabbedpane.addTab ("Avangate", avangatePanel);
        
        JLabel avangateOrderLabel = getLabel ("Avangate Order: ", JLabel.LEFT);
        avangatePanel.add (avangateOrderLabel);
        avangatePanel.add (avangateOrderField);
        
        JLabel avangateVendorLabel = getLabel ("Avangate ID: ", JLabel.LEFT);
        avangatePanel.add (avangateVendorLabel);
        avangatePanel.add (avangateVendorField);
        
        JLabel avangateProductLabel = getLabel ("Avangate Product ID: ", JLabel.LEFT);
        avangatePanel.add (avangateProductLabel);
        avangatePanel.add (avangateProductField);
        
        JLabel avangateCommissionRateLabel = getLabel ("Avangate Commission Rate: ", JLabel.LEFT);
        avangatePanel.add (avangateCommissionRateLabel);
        avangatePanel.add (avangateCommissionRateField);
        
        JLabel regnowOrderLabel = getLabel ("Regnow Order: ", JLabel.LEFT);
        avangatePanel.add (regnowOrderLabel);
        avangatePanel.add (regnowOrderField);
        
        JLabel regnowVendorLabel = getLabel ("Regnow ID: ", JLabel.LEFT);
        avangatePanel.add (regnowVendorLabel);
        avangatePanel.add (regnowVendorField);
        
        JLabel regnowProductLabel = getLabel ("Regnow Product ID: ", JLabel.LEFT);
        avangatePanel.add (regnowProductLabel);
        avangatePanel.add (regnowProductField);
        
        JLabel regnowCommissionRateLabel = getLabel ("Regnow Commission Rate: ", JLabel.LEFT);
        avangatePanel.add (regnowCommissionRateLabel);
        avangatePanel.add (regnowCommissionRateField);
        
        if (icon != null)
        {
            JPanel iconPanel = new IconPanel ();
        
            iconPanel.setPreferredSize (new Dimension (555, 100));
            avangatePanel.add (iconPanel);
        }
        ///////////////
        JPanel reportPanel = new JPanel (new BorderLayout ());
        JScrollPane repscr = new JScrollPane ();
        JViewport repport = repscr.getViewport ();
        repport.add (reportArea);
        reportPanel.add ("Center", repscr);
        
        tabbedpane.addTab ("Reports", reportPanel);
        
        cpanel.add ("Center", tabbedpane);
        add ("Center", cpanel);
        
        reset ();
    } //constructor end
    
    /** Visit us*/
    private final void visit ()
    {
        try
        {
            Runtime rt = Runtime.getRuntime ();
            String cmd = null;
            String os = System.getProperty ("os.name");
            if (os.indexOf ("Windows") != -1)
            {
                cmd = "explorer http://www.dilmerkezi.net/eng.html";
            }
            else
            {
                cmd = "iceweasel http://www.dilmerkezi.net/eng.html";
            }
            Process p = rt.exec (cmd);
            p.waitFor ();
        }
        catch (Exception e)
        {
            JOptionPane.showMessageDialog (mb, "Could not found dilmerkezi.net/eng.html !");
            return;
        }
    }
    
    /** Validate File*/
    private final boolean xmlvalidate ()
    {
        final String CRLF = "\r\n";
        StringBuffer sb = new StringBuffer ();
        
        sb.append ("Founded Problems Are;");
        sb.append (CRLF);
        sb.append ("--------------------------");
        sb.append (CRLF);
        
        String str = cmpNameField.getText ();
        int strlen = str.length ();
        if (str == null || strlen < 2 || strlen > 40)
        {
            sb.append (""+str+" -->"+" Company_Name length must be between 2-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = cmpAdr1Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 40)
        {
            sb.append (""+str+" -->"+" Address_1 length must be between 0-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = cmpAdr2Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 40)
        {
            sb.append (""+str+" -->"+" Address_2 length must be between 0-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = cmpcityField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 40)
        {
            sb.append (""+str+" -->"+" City_Town length must be between 2-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = cmpstateField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 30)
        {
            sb.append (""+str+" -->"+" State_Province length must be between 0-30 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = cmpzipField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 20)
        {
            sb.append (""+str+" -->"+" Zip_Postal_Code length must be between 0-20 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = cmpcountryField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 40)
        {
            sb.append (""+str+" -->"+" Country length must be between 2-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = cmpwebField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 77)
         { 
             sb.append (""+str+" -->"+" Company_WebSite_URL length must be between 9-77 characters");
             sb.append (CRLF);
             sb.append ("And Web Site URL must start with http://");
             sb.append (CRLF);
             sb.append (CRLF);
         }
        }
        
        str = authorNameField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 30)
        {
            sb.append (""+str+" -->"+" Author_First_Name length must be between 2-30 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = authorSurnameField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 30)
        {
            sb.append (""+str+" -->"+" Author_Last_Name length must be between 2-30 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = authorMailField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
        if (strlen < 8 || strlen > 72 || 
            str.indexOf ("@") < 2 ||
            str.indexOf (".") < 5)
            {
                sb.append (""+str+" -->"+" Author_Email length must be between 8-72 characters");
                sb.append (CRLF);
                sb.append ("And mail adress must has @ and . characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            } 
        }
        
        str = authorContactNameField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 30)
        {
            sb.append (""+str+" -->"+" Contact_First_Name length must be between 2-30 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }

        str = authorContactSurnameField.getText ();
        strlen = str.length ();
        if (strlen < 2 || strlen > 30)
        {
            sb.append (""+str+" -->"+" Contact_Last_Name length must be between 2-30 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = authorContactMailField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
          if (strlen < 8 || strlen > 72 || 
            str.indexOf ("@") < 2 ||
            str.indexOf (".") < 5)
            {
                sb.append (""+str+" -->"+" Contact_Email length must be between 8-72 characters");
                sb.append (CRLF);
                sb.append ("And mail adress must has @ and . characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportSalesMailField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
          if (strlen < 8 || strlen > 72 || 
            str.indexOf ("@") < 2 ||
            str.indexOf (".") < 5)
            {
                sb.append (""+str+" -->"+" Sales_Email length must be between 8-72 characters");
                sb.append (CRLF);
                sb.append ("And mail adress must has @ and . characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportMailField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
          if (strlen < 8 || strlen > 72 || 
            str.indexOf ("@") < 2 ||
            str.indexOf (".") < 5)
            {
                sb.append (""+str+" -->"+" Support_Email length must be between 8-72 characters");
                sb.append (CRLF);
                sb.append ("And mail adress must has @ and . characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportGeneralMailField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
          if (strlen < 8 || strlen > 72 || 
            str.indexOf ("@") < 2 ||
            str.indexOf (".") < 5)
            {
                sb.append (""+str+" -->"+" General_Email length must be between 8-72 characters");
                sb.append (CRLF);
                sb.append ("And mail adress must has @ and . characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportSalesPhoneField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
            if (strlen < 7 || strlen > 40 || isphone (str) == false)
            {
                sb.append (""+str+" -->"+" Sales_Phone length must be between 7-40 characters");
                sb.append (CRLF);
                sb.append ("And phone number must not be has illegal characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportPhoneField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
            if (strlen < 7 || strlen > 40 || isphone (str) == false)
            {
                sb.append (""+str+" -->"+" Support_Phone length must be between 7-40 characters");
                sb.append (CRLF);
                sb.append ("And phone number must not be has illegal characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportGeneralPhoneField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
            if (strlen < 7 || strlen > 40 || isphone (str) == false)
            {
                sb.append (""+str+" -->"+" General_Phone length must be between 7-40 characters");
                sb.append (CRLF);
                sb.append ("And phone number must not be has illegal characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = supportFaxField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
            if (strlen < 7 || strlen > 40 || isphone (str) == false)
            {
                sb.append (""+str+" -->"+" Fax_Phone length must be between 7-40 characters");
                sb.append (CRLF);
                sb.append ("And phone number must not be has illegal characters.");
                sb.append (CRLF);
                sb.append (CRLF);
            }
        }
        
        str = programNameField.getText ();
        strlen = str.length ();
        if (strlen < 1 || strlen > 40)
        {
            sb.append (""+str+" -->"+" Program_Name length must be between 1-40 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = programVersionField.getText ();
        strlen = str.length ();
        if (strlen < 1 || strlen > 15 || validdigit (str) == false)
        {
            sb.append (""+str+" -->"+" Program_Version length must be between 1-15 characters");
            sb.append (CRLF);
            sb.append ("And version text must not include illegal characters.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = programCostField.getText ();
        strlen = str.length ();
        if (validdigit (str) == false)
        {
            sb.append (""+str+" -->"+" Program_Cost_Dollars must not contains illegal characters.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = programCostOtherField.getText ();
        strlen = str.length ();
        if (validdigit (str) == false)
        {
            sb.append (""+str+" -->"+" Program_Cost_Other must not contains illegal characters.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = programChangeInfoField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 300)
        {
            sb.append (""+str+" -->"+" Program_Change_Info length must be between 0-300 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = programRequirementsField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 100)
        {
            sb.append (""+str+" -->"+" Program_System_Requirements length must be between 0-100 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = fileSizeBytesField.getText ();
        strlen = str.length ();
        if (strlen < 3 || strlen > 16 || puredigit (str) == false)
        {
            sb.append (""+str+" -->"+" File_Size_Bytes length must be between 3-16 characters");
            sb.append (CRLF);
            sb.append ("And Bytes value must not contains non-digit values.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = fileSizeKBField.getText ();
        strlen = str.length ();
        if (strlen < 1 || strlen > 12 || validdigit (str) == false)
        {
            sb.append (""+str+" -->"+" File_Size_K length must be between 1-12 characters");
            sb.append (CRLF);
            sb.append ("And KB value must not contains illegal characters.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = fileSizeMBField.getText ();
        strlen = str.length ();
        if (strlen < 1 || strlen > 8 || validdigit (str) == false)
        {
            sb.append (""+str+" -->"+" File_Size_MB length must be between 3-16 characters");
            sb.append (CRLF);
            sb.append ("And MB value must not contains illegal characters.");
            sb.append (CRLF);
            sb.append (CRLF);
        }        
        
        str = expireCountField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 15 || puredigit (str) == false)
        {
            sb.append (""+str+" -->"+" Expire_Count length must be between 0-15 characters");
            sb.append (CRLF);
            sb.append ("And expire count value must not contains non-digit values.");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = expireBasedOnField.getText ();
        if (str.equals ("Days") == false &&
            str.equals ("Uses") == false &&
            str.equals ("Either")==false &&
            str.equals ("Or") == false &&
            str.equals ("Either/Or") == false)
        {
            sb.append (""+str+" -->"+" Expire_Based_On Must Be Selected From 'Days|Uses|Either\\/Or'");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = expireOtherInfoField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 100)
        {
            sb.append (""+str+" -->"+" Expire_Other_Info length must be between 0-100 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        /////////////////////////
        str = descriptionKeywordsField.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" EN Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" EN Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" EN Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" EN Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450Field.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" EN Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000Area.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" EN Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        ///////////////////////////
        str = descriptionKeywordsFieldES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" ES Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" ES Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" ES Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" ES Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" ES Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaES.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" ES Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        ///////////////////////////
        str = descriptionKeywordsFieldDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" DE Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" DE Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" DE Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" DE Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" DE Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaDE.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" DE Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        //////////////////////////
        str = descriptionKeywordsFieldDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" DN Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" DN Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" DN Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" DN Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" DN Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaDN.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" DN Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        //////////////////////////
        str = descriptionKeywordsFieldPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" PR Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" PR Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" PR Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" PR Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" PR Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaPR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" PR Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        ///////////////////////////
        str = descriptionKeywordsFieldFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" FR Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" FR Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" FR Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" FR Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" FR Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaFR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" FR Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        ///////////////////////////
        str = descriptionKeywordsFieldTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" TR Keywords length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 
        
        str = description45FieldTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 45)
        {
            sb.append (""+str+" -->"+" TR Char_Desc_45 length must be between 0-45 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description80FieldTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 80)
        {
            sb.append (""+str+" -->"+" TR Char_Desc_80 length must be between 0-80 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }        

        str = description250FieldTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 250)
        {
            sb.append (""+str+" -->"+" TR Char_Desc_250 length must be between 0-250 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = description450FieldTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 450)
        {
            sb.append (""+str+" -->"+" TR Char_Desc_450 length must be between 0-450 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        } 

        str = description2000AreaTR.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" TR Char_Desc_2000 length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        /////////////////////////
        str = webApplicationInfoURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
             str.startsWith ("https://") == false) ||
             strlen < 9 || strlen > 127)
         {
             sb.append (""+str+" -->"+" Application_Info_URL length must be between 9-127 characters");
             sb.append (CRLF);
             sb.append ("And URL must start with http://");
             sb.append (CRLF);
             sb.append (CRLF);
          }
        }
        
        str = webApplicationOrderURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
             str.startsWith ("https://") == false) ||
             strlen < 9 || strlen > 127)
          {
             sb.append (""+str+" -->"+" Application_Order_URL length must be between 9-127 characters");
             sb.append (CRLF);
             sb.append ("And URL must start with http://");
             sb.append (CRLF);
             sb.append (CRLF);
          }
        }
        
        str = webApplicationScreenshotURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
             str.startsWith ("https://") == false) ||
             (str.endsWith (".png") == false &&
              str.endsWith (".jpg") == false &&
              str.endsWith (".gif") == false) ||
              strlen < 9 || strlen > 127)
          {
             sb.append (""+str+" -->"+" Application_Screenshot_URL length must be between 9-127 characters");
             sb.append (CRLF);
             sb.append ("And URL must start with http:// and must en dwith png|gif|jpg");
             sb.append (CRLF);
             sb.append (CRLF);
          }
        }        
        
        str = webApplicationIconURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            (str.endsWith (".png") == false &&
             str.endsWith (".jpg") == false &&
             str.endsWith (".gif") == false) ||
            strlen < 9 || strlen > 127)
         { 
            sb.append (""+str+" -->"+" Application_Icon_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http://, and the icon must be 32x32 gif|png|jpg");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        str = webApplicationPadURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127 || str.endsWith (".xml") == false)
         {
            sb.append (""+str+" -->"+" Application_XML_File_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http:// and the pad must end with '.xml'");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
    
        str = webApplicationDownloadPrimaryURLField.getText ();
        strlen = str.length ();
        if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) 
            || strlen < 9 || strlen > 127)
        {
            sb.append (""+str+" -->"+" Primary_Download_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http:// or ftp://");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = webApplicationDownloadSecondaryURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127)
         {
            sb.append (""+str+" -->"+" Secondary_Download_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http:// or ftp://");
            sb.append (CRLF);
            sb.append (CRLF);
         }        
        }
        
        str = webApplicationDownloadAdditional_1_URLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127)
         {
            sb.append (""+str+" -->"+" Additional_Download_URL_1 length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http:// or ftp://");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        str = webApplicationDownloadAdditional_2_URLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127)
         {
            sb.append (""+str+" -->"+" Additional_Download_URL_2 length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And URL must start with http:// or ftp://");
            sb.append (CRLF);
            sb.append (CRLF);
         }        
        }
        str = permissionsDistArea.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 2000)
        {
            sb.append (""+str+" -->"+" Distribution_Permissions length must be between 0-2000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = permissionsLicenceArea.getText ();
        strlen = str.length ();
        if (strlen < 0 || strlen > 20000)
        {
            sb.append (""+str+" -->"+" EULA length must be between 0-20000 characters");
            sb.append (CRLF);
            sb.append (CRLF);
        }
        
        str = affiliatesURLField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 77)
         { 
            sb.append (""+str+" -->"+" Affiliates_URL length must be between 9-77 characters");
            sb.append (CRLF);
            sb.append ("And Web Site URL must start with http://");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        str = affiliatesInfoPageField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        { 
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 77)
         {
            sb.append (""+str+" -->"+" Affiliates_Info_Page length must be between 9-77 characters");
            sb.append (CRLF);
            sb.append ("And Web Site URL must start with http://");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        str = avangateOrderField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127)
          {
            sb.append (""+str+" -->"+" Avangate_Order_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And Web Site URL must start with http://");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        str = regnowOrderField.getText ();
        strlen = str.length ();
        if (strlen > 0)
        {
         if ((str.startsWith ("http://") == false &&  
            str.startsWith ("https://") == false) ||
            strlen < 9 || strlen > 127)
          {
            sb.append (""+str+" -->"+" Regnow_Order_URL length must be between 9-127 characters");
            sb.append (CRLF);
            sb.append ("And Web Site URL must start with http://");
            sb.append (CRLF);
            sb.append (CRLF);
         }
        }
        
        String sbstr = sb.toString ();
        sb = null;
        reportArea.setText (sbstr);
        
        return true;
    } //xmlvalidate
    
    /**
     * @param str Current info
     *
     * @return true if is valid otherwise false
     */
    private final boolean isphone (String str)
    {
        char chrs [] = str.toCharArray ();
        int clen = chrs.length;
        char c = '*';
        for (int i=0; i<clen; i++)
        {
            c = str.charAt (i);
            if (Character.isDigit (c) == false &&
                c != '#' && c != '*' &&
                c != '(' && c != ')' &&
                c != '-' && c != '/' &&
                c != '_')
                return false;
        }
        
        return true;
    }
    
    
    /**
     * @param str Current info
     *
     * @return true if is valid otherwise false
     */
    private final boolean validdigit (String str)
    {
        char chrs [] = str.toCharArray ();
        int clen = chrs.length;
        char c = '*';
        for (int i=0; i<clen; i++)
        {
            c = str.charAt (i);
            if (Character.isDigit (c) == false && c != '.')
                return false;
        }
        return true;
    }
    
    /**
     * @param str Current info
     *
     * @return true if is valid otherwise false
     */
    private final boolean puredigit (String str)
    {
        char chrs [] = str.toCharArray ();
        int clen = chrs.length;
        char c = '*';
        for (int i=0; i<clen; i++)
        {
            c = str.charAt (i);
            if (Character.isDigit (c) == false)
                return false;
        }
        return true;
    }
    
    
    /** Reset boxes*/
    private final void resetBoxes ()
    {
        programReleaseBoxM.setSelectedIndex (0);
        programReleaseBoxD.setSelectedIndex (0);
        programReleaseBoxY.setSelectedIndex (0); 
        programCostOtherCodeBox.setSelectedIndex (0);
        programReleaseStatusBox.setSelectedIndex (2); 
        programTypeBox.setSelectedIndex (1); 
        programInstallSupportBox.setSelectedIndex (0); 
//        programOSSupportBox.setSelectedIndex (8);
        programLanguageBox.setSelectedIndex (0);
        programSpecificCategoryBox.setSelectedIndex (0);
        programCategoryBox.setSelectedIndex (0);
        expireHasBox.setSelectedIndex (1);
        expireDateBoxM.setSelectedIndex (0);
        expireDateBoxD.setSelectedIndex (0); 
        expireDateBoxY.setSelectedIndex (0); 
        affiliatesFormBox.setSelectedIndex (1);
        affiliatesASPFormBox.setSelectedIndex (1);
    }
    
    /** Set names*/
    private final void setNames ()
    {
        cmpNameField.setName ("Company_Name");
        cmpAdr1Field.setName ("Address_1");
        cmpAdr2Field.setName ("Address_2");
        cmpcityField.setName ("City_Town");
        cmpstateField.setName ("State_Province");
        cmpzipField.setName ("Zip_Postal_Code");
        cmpcountryField.setName ("Country");
        cmpwebField.setName ("Company_WebSite_URL");
        
        authorNameField.setName ("Author_First_Name");
        authorSurnameField.setName ("Author_Last_Name");
        authorMailField.setName ("Author_Email");
        authorContactNameField.setName ("Contact_First_Name");
        authorContactSurnameField.setName ("Contact_Last_Name");
        authorContactMailField.setName ("Contact_Email");
        
        supportSalesMailField.setName ("Sales_Email");
        supportMailField.setName ("Support_Email");
        supportGeneralMailField.setName ("General_Email");
        supportSalesPhoneField.setName ("Sales_Phone");
        supportPhoneField.setName ("Support_Phone");
        supportGeneralPhoneField.setName ("General_Phone");
        supportFaxField.setName ("Fax_Phone");
        
        programNameField.setName ("Program_Name");
        programVersionField.setName ("Program_Version");
        programReleaseBoxM.setName ("Program_Release_Month");
        programReleaseBoxD.setName ("Program_Release_Day");
        programReleaseBoxY.setName ("Program_Release_Year");
        programCostField.setName ("Program_Cost_Dollars");
        programCostOtherCodeBox.setName ("Program_Cost_Other_Code");
        programCostOtherField.setName ("Program_Cost_Other");
        programTypeBox.setName ("Program_Type");
        programReleaseStatusBox.setName ("Program_Release_Status");
        programInstallSupportBox.setName ("Program_Install_Support");
        programOSSupportBox.setName ("Program_OS_Support");
        programLanguageBox.setName ("Program_Language");
        programChangeInfoField.setName ("Program_Change_Info");
        programSpecificCategoryBox.setName ("Program_Specific_Category");
        programCategoryBox.setName ("Program_Category_Class");
        programRequirementsField.setName ("Program_System_Requirements");
        
        fileSizeBytesField.setName ("File_Size_Bytes");
        fileSizeKBField.setName ("File_Size_K");
        fileSizeMBField.setName ("File_Size_MB");
        
        expireHasBox.setName ("Has_Expire_Info");
        expireCountField.setName ("Expire_Count");
        expireBasedOnField.setName ("Expire_Based_On");
        expireOtherInfoField.setName ("Expire_Other_Info");
        expireDateBoxM.setName ("Expire_Month");
        expireDateBoxD.setName ("Expire_Day");
        expireDateBoxY.setName ("Expire_Year");

        descriptionKeywordsField.setName ("Keywords");
        description45Field.setName ("Char_Desc_45");
        description80Field.setName ("Char_Desc_80");
        description250Field.setName ("Char_Desc_250");
        description450Field.setName ("Char_Desc_450");
        description2000Area.setName ("Char_Desc_2000");

        descriptionKeywordsFieldES.setName ("Keywords");
        description45FieldES.setName ("Char_Desc_45");
        description80FieldES.setName ("Char_Desc_80");
        description250FieldES.setName ("Char_Desc_250");
        description450FieldES.setName ("Char_Desc_450");
        description2000AreaES.setName ("Char_Desc_2000");

        descriptionKeywordsFieldDN.setName ("Keywords");
        description45FieldDN.setName ("Char_Desc_45");
        description80FieldDN.setName ("Char_Desc_80");
        description250FieldDN.setName ("Char_Desc_250");
        description450FieldDN.setName ("Char_Desc_450");
        description2000AreaDN.setName ("Char_Desc_2000");

        descriptionKeywordsFieldDE.setName ("Keywords");
        description45FieldDE.setName ("Char_Desc_45");
        description80FieldDE.setName ("Char_Desc_80");
        description250FieldDE.setName ("Char_Desc_250");
        description450FieldDE.setName ("Char_Desc_450");
        description2000AreaDE.setName ("Char_Desc_2000");

        descriptionKeywordsFieldFR.setName ("Keywords");
        description45FieldFR.setName ("Char_Desc_45");
        description80FieldFR.setName ("Char_Desc_80");
        description250FieldFR.setName ("Char_Desc_250");
        description450FieldFR.setName ("Char_Desc_450");
        description2000AreaFR.setName ("Char_Desc_2000");

        descriptionKeywordsFieldPR.setName ("Keywords");
        description45FieldPR.setName ("Char_Desc_45");
        description80FieldPR.setName ("Char_Desc_80");
        description250FieldPR.setName ("Char_Desc_250");
        description450FieldPR.setName ("Char_Desc_450");
        description2000AreaPR.setName ("Char_Desc_2000");

        descriptionKeywordsFieldTR.setName ("Keywords");
        description45FieldTR.setName ("Char_Desc_45");
        description80FieldTR.setName ("Char_Desc_80");
        description250FieldTR.setName ("Char_Desc_250");
        description450FieldTR.setName ("Char_Desc_450");
        description2000AreaTR.setName ("Char_Desc_2000");

        webApplicationInfoURLField.setName ("Application_Info_URL");
        webApplicationOrderURLField.setName ("Application_Order_URL");
        webApplicationScreenshotURLField.setName ("Application_Screenshot_URL");
        webApplicationIconURLField.setName ("Application_Icon_URL");
        webApplicationPadURLField.setName ("Application_XML_File_URL");
        webApplicationDownloadPrimaryURLField.setName ("Primary_Download_URL");
        webApplicationDownloadSecondaryURLField.setName ("Secondary_Download_URL");
        webApplicationDownloadAdditional_1_URLField.setName ("Additional_Download_URL_1");
        webApplicationDownloadAdditional_2_URLField.setName ("Additional_Download_URL_2");

        permissionsDistArea.setName ("Distribution_Permissions");
        permissionsLicenceArea.setName ("EULA");

        affiliatesFormBox.setName ("Affiliates_FORM");
        affiliatesVersionField.setName ("Affiliates_VERSION");
        affiliatesURLField.setName ("Affiliates_URL");
        affiliatesInfoPageField.setName ("Affiliates_Information_Page");
        avangateOrderField.setName ("Affiliates_Avangate_Order_Page");
        avangateVendorField.setName ("Affiliates_Avangate_Vendor_ID");
        avangateProductField.setName ("Affiliates_Avangate_Product_ID");
        avangateCommissionRateField.setName ("Affiliates_Avangate_Maximum_Commission_Rate");
        regnowOrderField.setName ("Affiliates_Regnow_Order_Page");
        regnowVendorField.setName ("Affiliates_Regnow_Vendor_ID");
        regnowProductField.setName ("Affiliates_Regnow_Product_ID");
        regnowCommissionRateField.setName ("Affiliates_Regnow_Maximum_Commission_Rate");
        
        
        affiliatesASPFormBox.setName ("ASP_FORM");
        affiliatesASPMemberField.setName ("ASP_Member");
        affiliatesASPMemberNumberField.setName ("ASP_Member_Number");
    }; //setnames
    
    //
    /** File chooser filter*/
    private final class Filter
    extends javax.swing.filechooser.FileFilter
    {
    
        /** Description*/
        final String descstr = "XML Files";
        
        /**
         * @param f Current file in jfc tool
         * @return true if is acceptable
         */
        public final boolean accept (java.io.File f)
        {
            if (f.isDirectory ()) return true;
            String name = (f.getName ()).toLowerCase ();
            if (name.endsWith (".xml")) return true;
            return false;
        }
        
        /** @return Description*/
        public String getDescription ()
        {
            return descstr;
        }
    }
    //
    
    //
    /** File chooser txt, html filter*/
    private final class FilterTH
    extends javax.swing.filechooser.FileFilter
    {
    
        /** Description*/
        final String descstr = "TXT, HTML Files";
        
        /**
         * @param f Current file in jfc tool
         * @return true if is acceptable
         */
        public final boolean accept (java.io.File f)
        {
            if (f.isDirectory ()) return true;
            String name = (f.getName ()).toLowerCase ();
            if (name.endsWith (".htm") ||
                name.endsWith (".html") ||
                name.endsWith (".txt")) return true;
            return false;
        }
        
        /** @return Description*/
        public String getDescription ()
        {
            return descstr;
        }
    }
    //
    
    /** All components.setText ("")*/
    private final void reset ()
    {
        for (int i=0; i<componentsLength; i++)
        {
            if (components [i] instanceof JTextComponent)
            {
                ((JTextComponent)components [i]).setText ("");
            }
        }
        int ll = twodimcomp.length;
        int kc = 0;
        JTextComponent [] cmpss = null;
        
        for (int i=0; i<ll; i++)
        {
            cmpss = twodimcomp [i];
            kc = cmpss.length;
            for (int j=1; j<kc; j++)
            {
                twodimcomp [i][j].setText ("");
            }    
        }
        cmpwebField.setText ("http://");    
        descriptionLanguageField.setText ("English");
        descriptionLanguageFieldES.setText ("Spanish");
        descriptionLanguageFieldDE.setText ("German");
        descriptionLanguageFieldDN.setText ("Danish");
        descriptionLanguageFieldPR.setText ("Portuguese");
        descriptionLanguageFieldFR.setText ("French");
        descriptionLanguageFieldTR.setText ("Turkish");
        description45Field.setText ("45 chars");
        description80Field.setText ("80 chars");
        description250Field.setText ("250 chars");
        description450Field.setText ("450 chars");
        description2000Area.setText ("2000 chars");
        permissionsDistArea.setText ("Distribution Permissions");    
        permissionsLicenceArea.setText ("Licence");
        affiliatesVersionField.setText ("1.4");
        affiliatesURLField.setText (AFURL);
        affiliatesInfoPageField.setText ("Y");        
        affiliatesASPMemberField.setText ("N");        
    }
    
    //
    /** Custom panel*/
    private class IconPanel
          extends JPanel
    {
        /** Inner singleton constructor*/
        private IconPanel ()
        {
            super (true);
            setBorder (BorderFactory.createLineBorder (Color.black, 1));
            addMouseListener (new XAdapter ());
        }
        
        
        ///////
        /** Mouse Adapter*/
        private final class XAdapter
                extends MouseAdapter
        {
        
            /** @param evt Mouse Event object*/
            public final void mouseEntered (MouseEvent evt)
            {
                setCursor (Cursor.getPredefinedCursor (Cursor.HAND_CURSOR));
            }
            
            /** @param evt Mouse Event object*/
            public final void mouseExited (MouseEvent evt)
            {
                setCursor (Cursor.getPredefinedCursor (Cursor.DEFAULT_CURSOR));
                return;
            }
            
            /** @param evt Mouse Event object*/
            public final void mouseClicked (MouseEvent evt)
            {
                visit ();
                setCursor (Cursor.getPredefinedCursor (Cursor.DEFAULT_CURSOR));
                return;
            }
        }
        //////
        
        /** @param g Graphics object*/
        protected void paintComponent (Graphics g)
        {
           super.paintComponent (g);
           if (icon == null) return;
           g.drawImage (icon.getImage (), 
               ((this.getSize ().width/2)-(icon.getIconWidth ()/2)), 
               ((this.getSize ().height/2)-(icon.getIconHeight ()/2)), 
               this);
           return;
        }
    }
    //
    
    /**
     * @param strs Combobox values
     * @return Custom combobox
     */
    private final JComboBox getBox (String [] strs)
    {
        JComboBox b = new JComboBox (strs);
        b.setPreferredSize (new Dimension (460, 25));
        b.setMaximumRowCount (12);
        return b;
    }    
    
    /**
     * @param strs List values
     * @return Custom list
     */
    private final JList getList (String [] strs)
    {
        JList b = new JList (strs);
        b.setSelectionMode (ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
//        b.setPreferredSize (new Dimension (460, 25));
//        b.setMaximumRowCount (12);
        return b;
    }        
    
    /**
     * @param s Label text
     * @param c label position
     *
     * @return Custom label
     */
    private final JLabel getLabel (String s, int c)
    {
        JLabel l = new JLabel (s, c);
        l.setPreferredSize (new Dimension (100, 25));
        return l;
    }

    /**
     * @param s Label text
     * @param c label position
     *
     * @return Custom label
     */
    private final JLabel getLabel_2 (String s, int c)
    {
        JLabel l = new JLabel (s, c);
        l.setPreferredSize (new Dimension (100, 23));
        return l;
    }

    /**
     * @param s Button text
     *
     * @return Custom Button
     */
    private JButton getButton (String s)
    {
        JButton b = new JButton (s);
        return b;
    }
    
    /**
     * @param s Menu text
     *
     * @return Custom menu
     */
    private JMenu getMenu (String s)
    {
        JMenu m = new JMenu (s);
        return m;
    }
    
    /**
     * @param s Menuitem text
     *
     * @return Custom menuitem
     */
    private JMenuItem getItem (String s)
    {
        JMenuItem mi = new JMenuItem (s);
        return mi;
    }    
    
    /**
     * @param s Panel tabbed pane text
     *
     * @return Custom panel
     */
    private JPanel getPanel (String s)
    {
        JPanel p = new JPanel ();
        p.setBorder (BorderFactory.createTitledBorder (s));
        return p;
    }    
        
    /**
     * @param s Text field text
     *
     * @return Custom text field
     */
    private final JTextField getField (String s)
    {
        final JTextField tf = new JTextField (s);
        tf.addMouseListener (new MouseAdapter ()
        {
            public void mouseClicked (MouseEvent evt)
            {
                if (evt.getClickCount () == 0x2)
                {
                    tf.selectAll ();
                }
            }
        });
        tf.setDragEnabled (true);
        tf.setForeground (Color.black);
        tf.setPreferredSize (new Dimension (460, 25));
        return tf;
    }
    
    /**
     * @param s Text field text
     *
     * @return Custom text field
     */
    private final JTextField getField_2 (String s)
    {
        final JTextField tf = new JTextField (s);
        tf.addMouseListener (new MouseAdapter ()
        {
            public void mouseClicked (MouseEvent evt)
            {
                if (evt.getClickCount () == 0x2)
                {
                    tf.selectAll ();
                }
            }
        });
        tf.setDragEnabled (true);
        tf.setForeground (Color.black);
        tf.setPreferredSize (new Dimension (460, 23));
        return tf;
    }    
    
    /**
     * @param s Text area text
     *
     * @return Custom text pane
     */
    private final JTextPane getArea (String s)
    {
        final JTextPane txt = new JTextPane ();
        Font f = txt.getFont ();
        Font nf = new Font (f.getFamily (), f.getStyle (), 0xC);
        txt.setFont (nf);
        
        txt.setText (s);
        txt.addMouseListener (new MouseAdapter ()
        {
            public void mouseClicked (MouseEvent evt)
            {
                if (evt.getClickCount () == 0x2)
                {
                    txt.selectAll ();
                }
            }
        });
        txt.setDragEnabled (true);
        return txt;
    }
    
    /**
     * @return true if xml file generated properly
     */
    private final boolean generate ()
    throws Exception
    {
        int rep = jfc.showSaveDialog (mb);
        if (rep != JFileChooser.APPROVE_OPTION) return false;
        
        File f = jfc.getSelectedFile ();
        if ( f == null  ||
            (f.exists () && f.isDirectory ()))
        {
            JOptionPane.showMessageDialog (mb, "Please select a new file name!");
            return false;
        }
        
        boolean sigue = true;
        if (f.exists ())
        {
            String s = JOptionPane.showInputDialog (mb, ""+f.getName ()+ " already exists.\nOwerrite it (y/n)?");
            if (s == null) sigue = false;
            if (s.equalsIgnoreCase ("y")) sigue = true;
            else sigue = false;
        }
        
        if (sigue == false) return false;
        
        OutputStream fos = null;
        OutputStream bos = null;
        PrintStream ps = null;
        
        try
        {
            fos = new FileOutputStream (f);
            bos = new BufferedOutputStream (fos);
            ps = new PrintStream (bos, true, "UTF-8");    
        }
        catch (Exception e)
        {
            e.printStackTrace ();
            return false;
        }
        
        final String CRLF = "\r\n";
        
        try
        {
            ps.print ("<?xml version=\"1.0\" ?>");
            ps.print (CRLF);
            
            ps.print ("<XML_DIZ_INFO>");
            ps.print (CRLF);
            
            ps.print ("\t<MASTER_PAD_VERSION_INFO>");
            ps.print (CRLF);
            
            ps.print ("\t\t<MASTER_PAD_VERSION>3.10</MASTER_PAD_VERSION>");
            ps.print (CRLF);
            
            ps.print ("\t\t<MASTER_PAD_EDITOR>Java PAD Generator 1.0 http://www.dilmerkezi.net/eng.html</MASTER_PAD_EDITOR>");
            ps.print (CRLF);            

            ps.print ("\t\t<MASTER_PAD_VERSION>Open Source GPL Licensed Easy Java PAD Generator Program</MASTER_PAD_VERSION>");
            ps.print (CRLF); 
            
            ps.print ("\t</MASTER_PAD_VERSION_INFO>");
            ps.print (CRLF);
            
            ps.print ("\t<Company_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Company_Name", cmpNameField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Address_1", cmpAdr1Field));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Address_2", cmpAdr2Field));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("City_Town", cmpcityField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("State_Province", cmpstateField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Zip_Postal_Code", cmpzipField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Country", cmpcountryField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Company_WebSite_URL", cmpwebField));
            ps.print (CRLF);
            
            ps.print ("\t\t<Contact_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Author_First_Name", authorNameField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Author_Last_Name", authorSurnameField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Author_Email", authorMailField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Contact_First_Name", authorContactNameField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Contact_Last_Name", authorContactSurnameField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Contact_Email", authorContactMailField));
            ps.print (CRLF);
            
            ps.print ("\t\t</Contact_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t<Support_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Sales_Email", supportSalesMailField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Support_Email", supportMailField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("General_Email", supportGeneralMailField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Sales_Phone", supportSalesPhoneField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Support_Phone", supportPhoneField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("General_Phone", supportGeneralPhoneField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Fax_Phone", supportFaxField));
            ps.print (CRLF);
            
            ps.print ("\t\t</Support_Info>");
            ps.print (CRLF);
            
            ps.print ("\t</Company_Info>");
            ps.print (CRLF);
            
            ps.print ("\t<Program_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_Name", programNameField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_Version", programVersionField));
            ps.print (CRLF);
                        
            ps.print ("\t\t"+getValueBox ("Program_Release_Month", programReleaseBoxM));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Release_Day", programReleaseBoxD));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Release_Year", programReleaseBoxY));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_Cost_Dollars", programCostField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Cost_Other_Code", programCostOtherCodeBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_Cost_Other", programCostOtherField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Type", programTypeBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Release_Status", programReleaseStatusBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Install_Support", programInstallSupportBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueList ("Program_OS_Support", programOSSupportBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Language", programLanguageBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_Change_Info", programChangeInfoField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Specific_Category", programSpecificCategoryBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Program_Category_Class", programCategoryBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Program_System_Requirements", programRequirementsField));
            ps.print (CRLF);
            
            ps.print ("\t\t<File_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("File_Size_Bytes", fileSizeBytesField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("File_Size_K", fileSizeKBField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("File_Size_MB", fileSizeMBField));
            ps.print (CRLF);
            
            ps.print ("\t\t</File_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t<Expire_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueBox ("Has_Expire_Info", expireHasBox));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Expire_Count", expireCountField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Expire_Based_On", expireBasedOnField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Expire_Other_Info", expireOtherInfoField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueBox ("Expire_Month", expireDateBoxM));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueBox ("Expire_Day", expireDateBoxD));
            ps.print (CRLF);

            ps.print ("\t\t\t"+getValueBox ("Expire_Year", expireDateBoxY));
            ps.print (CRLF);

            ps.print ("\t\t</Expire_Info>");
            ps.print (CRLF);
            
            ps.print ("\t</Program_Info>");
            ps.print (CRLF);
            
            ps.print ("\t<Program_Descriptions>");
            ps.print (CRLF);            
            
            ////////////////////////////////////
            ps.print ("\t\t<"+descriptionLanguageField.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45Field));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80Field));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250Field));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450Field));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000Area));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageField.getText ()+">");
            ps.print (CRLF);    
            ///////////////////////
            if (multilengual)
            {
            ps.print ("\t\t<"+descriptionLanguageFieldDE.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldDE));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldDE));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldDE));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldDE));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldDE));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaDE));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldDE.getText ()+">");
            ps.print (CRLF);    
            ///////////////////////
            ps.print ("\t\t<"+descriptionLanguageFieldES.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldES));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldES));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldES));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldES));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldES));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaES));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldES.getText ()+">");
            ps.print (CRLF);    
            //////////////////////
            ps.print ("\t\t<"+descriptionLanguageFieldDN.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldDN));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldDN));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldDN));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldDN));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldDN));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaDN));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldDN.getText ()+">");
            ps.print (CRLF);    
            /////////////////////
            ps.print ("\t\t<"+descriptionLanguageFieldFR.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldFR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldFR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldFR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldFR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldFR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaFR));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldFR.getText ()+">");
            ps.print (CRLF);    
            //////////////////
            ps.print ("\t\t<"+descriptionLanguageFieldPR.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldPR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldPR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldPR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldPR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldPR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaPR));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldPR.getText ()+">");
            ps.print (CRLF);    
            ////////////////////
            ps.print ("\t\t<"+descriptionLanguageFieldTR.getText ()+">");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Keywords", descriptionKeywordsFieldTR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_45", description45FieldTR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_80", description80FieldTR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_250", description250FieldTR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Char_Desc_450", description450FieldTR));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValueX ("Char_Desc_2000", description2000AreaTR));
            ps.print (CRLF);
    
            ps.print ("\t\t</"+descriptionLanguageFieldTR.getText ()+">");
            ps.print (CRLF);    
            //////////////////
            //descriptionLanguageField, ES, DE, DN, PR, FR,TR
            }
            ps.print ("\t</Program_Descriptions>");
            ps.print (CRLF);
            
            ps.print ("\t<Web_Info>");
            ps.print (CRLF);
            
            ps.print ("\t\t<Application_URLs>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Application_Info_URL", webApplicationInfoURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Application_Order_URL", webApplicationOrderURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Application_Screenshot_URL", webApplicationScreenshotURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Application_Icon_URL", webApplicationIconURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Application_XML_File_URL", webApplicationPadURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t</Application_URLs>");
            ps.print (CRLF);
            
            ps.print ("\t\t<Download_URLs>");
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Primary_Download_URL", webApplicationDownloadPrimaryURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Secondary_Download_URL", webApplicationDownloadSecondaryURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Additional_Download_URL_1", webApplicationDownloadAdditional_1_URLField));
            ps.print (CRLF);
            
            ps.print ("\t\t\t"+getValue ("Additional_Download_URL_2", webApplicationDownloadAdditional_2_URLField));
            ps.print (CRLF);
            
            ps.print ("\t\t</Download_URLs>");
            ps.print (CRLF);
            
            ps.print ("\t</Web_Info>");
            ps.print (CRLF);
            
            ps.print ("\t<Permissions>");
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueX ("Distribution_Permissions", permissionsDistArea));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueX ("EULA", permissionsLicenceArea));
            ps.print (CRLF);
            
            ps.print ("\t</Permissions>");
            ps.print (CRLF);
            
            ps.print ("\t<Affiliates>");
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("Affiliates_FORM", affiliatesFormBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_VERSION", affiliatesVersionField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_URL", affiliatesURLField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Information_Page", affiliatesInfoPageField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Avangate_Order_Page", avangateOrderField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Avangate_Vendor_ID", avangateVendorField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Avangate_Product_ID", avangateProductField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Avangate_Maximum_Commission_Rate", avangateCommissionRateField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Regnow_Order_Page", regnowOrderField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Regnow_Vendor_ID", regnowVendorField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Regnow_Product_ID", regnowProductField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("Affiliates_Regnow_Maximum_Commission_Rate", regnowCommissionRateField));
            ps.print (CRLF);
            
            
            ps.print ("\t</Affiliates>");
            ps.print (CRLF);
            
            ps.print ("\t<ASP>");
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValueBox ("ASP_FORM", affiliatesASPFormBox));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("ASP_MEMBER", affiliatesASPMemberField));
            ps.print (CRLF);
            
            ps.print ("\t\t"+getValue ("ASP_Member_Number", affiliatesASPMemberNumberField));
            ps.print (CRLF);
            
            ps.print ("\t</ASP>");
            ps.print (CRLF);
            
            ps.print ("</XML_DIZ_INFO>");
            ps.print (CRLF);
        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }
                
        close (ps, bos, fos);
        return true;
    }//generate ...
    

    //Generate HTML
    /**
     * @return true if html file generated properly
     */
    private final boolean generateHTML ()
    throws Exception
    {
        int rep = jfcTH.showSaveDialog (mb);
        if (rep != JFileChooser.APPROVE_OPTION) return false;
        
        File f = jfcTH.getSelectedFile ();
        if ( f == null  ||
            (f.exists () && f.isDirectory ()))
        {
            JOptionPane.showMessageDialog (mb, "Please select a new file name!");
            return false;
        }
        
        boolean sigue = true;
        if (f.exists ())
        {
            String s = JOptionPane.showInputDialog (mb, ""+f.getName ()+ " already exists.\nOwerrite it (y/n)?");
            if (s == null) sigue = false;
            if (s.equalsIgnoreCase ("y")) sigue = true;
            else sigue = false;
        }
        
        if (sigue == false) return false;
        
        OutputStream fos = null;
        OutputStream bos = null;
        PrintStream ps = null;
        
        try
        {
            fos = new FileOutputStream (f);
            bos = new BufferedOutputStream (fos);
            ps = new PrintStream (bos, true, "UTF-8");    
        }
        catch (Exception e)
        {
            e.printStackTrace ();
            return false;
        }
        
        final String CRLF = "\r\n";
        
        try
        {
            ps.print ("<html><head><title>"+f.getName ()+"</title></head>");
            ps.print (CRLF);
            
            ps.print ("<body>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Company Name: </font>");
            ps.print (cmpNameField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Address 1: </font>");
            ps.print (cmpAdr1Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Address 2: </font>");
            ps.print (cmpAdr2Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">City Town: </font>");
            ps.print (cmpcityField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">State Province: </font>");
            ps.print (cmpstateField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Zip Code: </font>");
            ps.print (cmpzipField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Country: </font>");
            ps.print (cmpcountryField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Company Web: </font>");
            ps.print (cmpwebField.getText ());
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            
            
            ps.print ("<font color=\"blue\">Author Name: </font>");
            ps.print (authorNameField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Author Surname: </font>");
            ps.print (authorSurnameField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Author E-Mail: </font>");
            ps.print (authorMailField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Contact E-Mail: </font>");
            ps.print (authorContactMailField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Phone: </font>");
            ps.print (supportSalesPhoneField.getText ());
            ps.print ("<p><p><p><h3>PROGRAM</h3><br>====================<br><br>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Program Name: </font>");
            ps.print (programNameField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Version: </font>");
            ps.print (programVersionField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Release Date (Month/Day/Year): </font>");            
            ps.print (""+
                 (String)programReleaseBoxM.getSelectedItem ()+"/"+
                 (String)programReleaseBoxD.getSelectedItem ()+"/"+
                 (String) programReleaseBoxY.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Cost (USD): </font>");
            ps.print (programCostField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Cost Other Currency: </font>");
            ps.print ((String)programCostOtherCodeBox.getSelectedItem());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Cost Other: </font>");
            ps.print (programCostOtherField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Type: </font>");
            ps.print ((String)programTypeBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Release Status: </font>");
            ps.print ((String)programReleaseStatusBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Install Support: </font>");
            ps.print ((String)programInstallSupportBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">OS Support: </font>");
            Object vals [] = programOSSupportBox.getSelectedValues ();
            int vallen = vals.length;
            for (int i=0; i<vallen; i++)
            {
                ps.print ((String)vals [i]);
                if (i!=vallen-1)
                    ps.print (",");
            }
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Language: </font>");
            ps.print ((String)programLanguageBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Change Info: </font>");
            ps.print (programChangeInfoField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Specific Category: </font>");
            ps.print ((String)programSpecificCategoryBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Full Category: </font>");
            ps.print ((String)programCategoryBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">System Requirements: </font>");
            ps.print (programRequirementsField.getText ());
            ps.print ("<br>======================<p><p><p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">File Size Bytes: </font>");
            ps.print (fileSizeBytesField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">File Size KB: </font>");
            ps.print (fileSizeKBField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">File Size MB: </font>");
            ps.print (fileSizeMBField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Has Expire Info: </font>");
            ps.print ((String) expireHasBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Expire Count: </font>");
            ps.print (expireCountField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Expire Based On: </font>");
            ps.print (expireBasedOnField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Expire Other Info: </font>");
            ps.print (expireOtherInfoField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Expire Date (Month/Day/Year): </font>");
            ps.print ((String)expireDateBoxM.getSelectedItem ()+"/");
            ps.print ((String)expireDateBoxD.getSelectedItem ()+"/");
            ps.print ((String)expireDateBoxY.getSelectedItem ());
            ps.print ("<p><p><p><p>");
            ps.print (CRLF);
            
            ////////////////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450Field.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000Area.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            ///////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldDE.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaDE.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            //////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldES.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaES.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            //////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldDN.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaDN.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            /////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldFR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaFR.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            //////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldPR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaPR.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            /////////////////////
            ps.print ("<font color=\"blue\">Description Language: </font>");
            ps.print (descriptionLanguageFieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Keywords: </font>");
            ps.print (descriptionKeywordsFieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (45 Caharacters): </font>");
            ps.print (description45FieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (80 Caharacters): </font>");
            ps.print (description80FieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (250 Caharacters): </font>");
            ps.print (description250FieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (450 Caharacters): </font>");
            ps.print (description450FieldTR.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Description (2000 Caharacters): </font>");
            ps.print (multitext (description2000AreaTR.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            ////////////////////
            //descriptionLanguageField, ES, DE, DN, PR, FR,TR
            ps.print ("<font color=\"blue\">Application Info URL: </font>");
            ps.print (webApplicationInfoURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Application Order URL: </font>");
            ps.print (webApplicationOrderURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Application Screenshot URL: </font>");
            ps.print (webApplicationScreenshotURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Application Icon URL: </font>");
            ps.print (webApplicationIconURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Application PAD URL: </font>");
            ps.print (webApplicationPadURLField.getText ());
            ps.print ("<p><p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Primary Download URL: </font>");
            ps.print (webApplicationDownloadPrimaryURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Secondary Download URL: </font>");
            ps.print (webApplicationDownloadSecondaryURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Additional Download URL 1: </font>");
            ps.print (webApplicationDownloadAdditional_1_URLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Additional Download URL 2: </font>");
            ps.print (webApplicationDownloadAdditional_2_URLField.getText ());
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            
            
            ps.print ("<font color=\"blue\">Distribution Permissions:<br> </font>");
            ps.print (multitext (permissionsDistArea.getText (), true));
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">EULA:<br> </font>");
            ps.print (multitext (permissionsLicenceArea.getText (), true));
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Affiliates Form: </font>");
            ps.print ((String)affiliatesFormBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Affiliates Version: </font>");
            ps.print (affiliatesVersionField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Affiliates URL: </font>");
            ps.print (affiliatesURLField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Affiliates Info Page: </font>");
            ps.print (affiliatesInfoPageField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Avangate Order Page: </font>");
            ps.print (avangateOrderField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Avangate Vendor ID: </font>");
            ps.print (avangateVendorField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Avangate Product ID: </font>");
            ps.print (avangateProductField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Avangate Commission Rate: </font>");
            ps.print (avangateCommissionRateField.getText ());
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Regnow Order Page: </font>");
            ps.print (regnowOrderField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Regnow Vendor ID: </font>");
            ps.print (regnowVendorField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Regnow Product ID: </font>");
            ps.print (regnowProductField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">Regnow Commission Rate: </font>");
            ps.print (regnowCommissionRateField.getText ());
            ps.print ("<p><p><p>");
            ps.print (CRLF);
            
            
            ps.print ("<font color=\"blue\">ASP Form: </font>");
            ps.print ((String)affiliatesASPFormBox.getSelectedItem ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">ASP Member: </font>");
            ps.print (affiliatesASPMemberField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("<font color=\"blue\">ASP Member Number: </font>");
            ps.print (affiliatesASPMemberNumberField.getText ());
            ps.print ("<p>");
            ps.print (CRLF);
            
            ps.print ("</body></html>");
            ps.print (CRLF);
        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }
                
        close (ps, bos, fos);
        return true;
    }//generate ...

    //Generate TXT
    /**
     * @return true if html file generated properly
     */
    private final boolean generateTXT ()
    throws Exception
    {
        int rep = jfcTH.showSaveDialog (mb);
        if (rep != JFileChooser.APPROVE_OPTION) return false;
        
        File f = jfcTH.getSelectedFile ();
        if ( f == null  ||
            (f.exists () && f.isDirectory ()))
        {
            JOptionPane.showMessageDialog (mb, "Please select a new file name!");
            return false;
        }
        
        boolean sigue = true;
        if (f.exists ())
        {
            String s = JOptionPane.showInputDialog (mb, ""+f.getName ()+ " already exists.\nOwerrite it (y/n)?");
            if (s == null) sigue = false;
            if (s.equalsIgnoreCase ("y")) sigue = true;
            else sigue = false;
        }
        
        if (sigue == false) return false;
        
        OutputStream fos = null;
        OutputStream bos = null;
        PrintStream ps = null;
        
        try
        {
            fos = new FileOutputStream (f);
            bos = new BufferedOutputStream (fos);
            ps = new PrintStream (bos, true, "UTF-8");    
        }
        catch (Exception e)
        {
            e.printStackTrace ();
            return false;
        }
        
        final String CRLF = "\r\n";
        
        try
        {
            ps.print ("Company Name: ");
            ps.print (cmpNameField.getText ());
            ps.print (CRLF);
            
            ps.print ("Address 1: ");
            ps.print (cmpAdr1Field.getText ());
            ps.print (CRLF);
            
            ps.print ("Address 2: ");
            ps.print (cmpAdr2Field.getText ());
            ps.print (CRLF);
            
            ps.print ("City Town: ");
            ps.print (cmpcityField.getText ());
            ps.print (CRLF);
            
            ps.print ("State Province: ");
            ps.print (cmpstateField.getText ());
            ps.print (CRLF);
            
            ps.print ("Zip Code: ");
            ps.print (cmpzipField.getText ());
            ps.print (CRLF);
            
            ps.print ("Country: ");
            ps.print (cmpcountryField.getText ());
            ps.print (CRLF);
            
            ps.print ("Company Web: ");
            ps.print (cmpwebField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);
            
            ps.print ("Author Name: ");
            ps.print (authorNameField.getText ());
            ps.print (CRLF);
            
            ps.print ("Author Surname: ");
            ps.print (authorSurnameField.getText ());
            ps.print (CRLF);
            
            ps.print ("Author E-Mail: ");
            ps.print (authorMailField.getText ());
            ps.print (CRLF);
            
            ps.print ("Contact E-Mail: ");
            ps.print (authorContactMailField.getText ());
            ps.print (CRLF);
            
            ps.print ("Phone: ");
            ps.print (supportSalesPhoneField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print ("PROGRAM");
            ps.print (CRLF);
            ps.print ("====================");
            ps.print (CRLF);
            ps.print (CRLF);
            
            ps.print ("Program Name: ");
            ps.print (programNameField.getText ());
            ps.print (CRLF);
            
            ps.print ("Version: ");
            ps.print (programVersionField.getText ());
            ps.print (CRLF);
            
            ps.print ("Release Date (Month/Day/Year): ");            
            ps.print (""+
                 (String)programReleaseBoxM.getSelectedItem ()+"/"+
                 (String)programReleaseBoxD.getSelectedItem ()+"/"+
                 (String) programReleaseBoxY.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Cost (USD): ");
            ps.print (programCostField.getText ());
            ps.print (CRLF);
            
            ps.print ("Cost Other Currency: ");
            ps.print ((String)programCostOtherCodeBox.getSelectedItem());
            ps.print (CRLF);
            
            ps.print ("Cost Other: ");
            ps.print (programCostOtherField.getText ());
            ps.print (CRLF);
            
            ps.print ("Type: ");
            ps.print ((String)programTypeBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Release Status: ");
            ps.print ((String)programReleaseStatusBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Install Support: ");
            ps.print ((String)programInstallSupportBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("OS Support: ");
            Object vals [] = programOSSupportBox.getSelectedValues ();
            int vallen = vals.length;
            for (int i=0; i<vallen; i++)
            {
                ps.print ((String)vals [i]);
                if (i!=vallen-1)
                    ps.print (",");
            }
            ps.print (CRLF);
            
            ps.print ("Language: ");
            ps.print ((String)programLanguageBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Change Info: ");
            ps.print (programChangeInfoField.getText ());
            ps.print (CRLF);
            
            ps.print ("Specific Category: ");
            ps.print ((String)programSpecificCategoryBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Full Category: ");
            ps.print ((String)programCategoryBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("System Requirements: ");
            ps.print (programRequirementsField.getText ());
            ps.print (CRLF);
            ps.print ("======================");
            ps.print (CRLF);
            ps.print (CRLF);
            
            ps.print ("File Size Bytes: ");
            ps.print (fileSizeBytesField.getText ());
            ps.print (CRLF);
            
            ps.print ("File Size KB: ");
            ps.print (fileSizeKBField.getText ());
            ps.print (CRLF);
            
            ps.print ("File Size MB: ");
            ps.print (fileSizeMBField.getText ());
            ps.print (CRLF);
            
            ps.print ("Has Expire Info: ");
            ps.print ((String) expireHasBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Expire Count: ");
            ps.print (expireCountField.getText ());
            ps.print (CRLF);
            
            ps.print ("Expire Based On: ");
            ps.print (expireBasedOnField.getText ());
            ps.print (CRLF);
            
            ps.print ("Expire Other Info: ");
            ps.print (expireOtherInfoField.getText ());
            ps.print (CRLF);
            
            ps.print ("Expire Date (Month/Day/Year): ");
            ps.print ((String)expireDateBoxM.getSelectedItem ()+"/");
            ps.print ((String)expireDateBoxD.getSelectedItem ()+"/");
            ps.print ((String)expireDateBoxY.getSelectedItem ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);
            
            /////////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageField.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsField.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45Field.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80Field.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250Field.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450Field.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000Area.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            //////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldDE.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaDE.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            /////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldES.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaES.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            ///////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldDN.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaDN.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            //////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldFR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaFR.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            ///////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldPR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaPR.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            //////////////////////////
            ps.print ("Description Language: ");
            ps.print (descriptionLanguageFieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Keywords: ");
            ps.print (descriptionKeywordsFieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (45 Caharacters): ");
            ps.print (description45FieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (80 Caharacters): ");
            ps.print (description80FieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (250 Caharacters): ");
            ps.print (description250FieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (450 Caharacters): ");
            ps.print (description450FieldTR.getText ());
            ps.print (CRLF);
            
            ps.print ("Description (2000 Caharacters): ");
            ps.print (multitext (description2000AreaTR.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            ////////////////////////////
            //descriptionLanguageField, ES, DE, DN, PR, FR,TR
            ps.print ("Application Info URL: ");
            ps.print (webApplicationInfoURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Application Order URL: ");
            ps.print (webApplicationOrderURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Application Screenshot URL: ");
            ps.print (webApplicationScreenshotURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Application Icon URL: ");
            ps.print (webApplicationIconURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Application PAD URL: ");
            ps.print (webApplicationPadURLField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            
            ps.print ("Primary Download URL: ");
            ps.print (webApplicationDownloadPrimaryURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Secondary Download URL: ");
            ps.print (webApplicationDownloadSecondaryURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Additional Download URL 1: ");
            ps.print (webApplicationDownloadAdditional_1_URLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Additional Download URL 2: ");
            ps.print (webApplicationDownloadAdditional_2_URLField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);
                        
            ps.print ("Distribution Permissions:\n");
            ps.print (multitext (permissionsDistArea.getText (), false));
            ps.print (CRLF);
            
            ps.print ("EULA:\n");
            ps.print (multitext (permissionsLicenceArea.getText (), false));
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);
            
            ps.print ("Affiliates Form: ");
            ps.print ((String)affiliatesFormBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("Affiliates Version: ");
            ps.print (affiliatesVersionField.getText ());
            ps.print (CRLF);
            
            ps.print ("Affiliates URL: ");
            ps.print (affiliatesURLField.getText ());
            ps.print (CRLF);
            
            ps.print ("Affiliates Info Page: ");
            ps.print (affiliatesInfoPageField.getText ());
            ps.print (CRLF);
            
            ps.print ("Avangate Order Page: ");
            ps.print (avangateOrderField.getText ());
            ps.print (CRLF);
            
            ps.print ("Avangate Vendor ID: ");
            ps.print (avangateVendorField.getText ());
            ps.print (CRLF);
            
            ps.print ("Avangate Product ID: ");
            ps.print (avangateProductField.getText ());
            ps.print (CRLF);
            
            ps.print ("Avangate Commission Rate: ");
            ps.print (avangateCommissionRateField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);

            ps.print ("Regnow Order Page: ");
            ps.print (regnowOrderField.getText ());
            ps.print (CRLF);
            
            ps.print ("Regnow Vendor ID: ");
            ps.print (regnowVendorField.getText ());
            ps.print (CRLF);
            
            ps.print ("Regnow Product ID: ");
            ps.print (regnowProductField.getText ());
            ps.print (CRLF);
            
            ps.print ("Regnow Commission Rate: ");
            ps.print (regnowCommissionRateField.getText ());
            ps.print (CRLF);
            ps.print (CRLF);
            ps.print (CRLF);

            
            ps.print ("ASP Form: ");
            ps.print ((String)affiliatesASPFormBox.getSelectedItem ());
            ps.print (CRLF);
            
            ps.print ("ASP Member: ");
            ps.print (affiliatesASPMemberField.getText ());
            ps.print (CRLF);
            
            ps.print ("ASP Member Number: ");
            ps.print (affiliatesASPMemberNumberField.getText ());
            ps.print (CRLF);
        }
        catch (Exception e)
        {
            e.printStackTrace ();
        }
                
        close (ps, bos, fos);
        return true;
    }//generate ...

    /**
     * Closes ps, bos, fos streams
     */
    private final void close (PrintStream ps, OutputStream bos,
        OutputStream fos)
    {
        try
        {
            if (ps != null)
            {
                ps.flush ();
                ps.close ();
            }
            if (bos != null)
            {
                bos.flush ();
                bos.close ();            
            }
            if (fos != null)
            {
                fos.flush ();
                fos.close ();            
            }
        }
        catch (Exception e)
        {}
        finally
        {
            try
            {
                if (ps != null)
                {
                    ps.flush ();
                    ps.close ();
                }
                if (bos != null)
                { 
                    bos.flush ();
                    bos.close ();            
                }
                if (fos != null)
                {
                    fos.flush ();
                    fos.close ();            
                }
            }
            catch (Exception e)
            {}
        }
    }
    
    
    /**
     * @param text Source text
     * @param ishtml Html or txt?
     * @return Multi line text
     */
    private final String multitext (String text, boolean ishtml)
    {
        StringBuffer sb = new StringBuffer ();
        Reader strr = null;
        BufferedReader br = null;
        
        String CRLF = "";
        
        if (ishtml)
        {
            CRLF = ("<p>"+"\r\n");
        }
        else
        {
            CRLF = "\r\n";
        }
        
        try
        {
            strr = new StringReader (text);
            br = new BufferedReader (strr);
            String line = null;
            while ( (line=br.readLine ()) != null )
            {
                sb.append (line);
                sb.append (CRLF);
            }
        }
        catch (Exception e)
        {
//            close (strr, br);
//            return text;
        }
        
        close (strr, br);
        
        String sbstr = sb.toString ();
        sb = null;
        
        return sbstr;
    }
    
    /**
     * @param tag Current tag
     * @param tx Current text component
     *
     * @return Tag value
     */
    private final String getValue (String tag, JTextComponent tx)
    {
        StringBuffer sb = new StringBuffer ();
        sb.append ("<");
        sb.append (tag);
        
        String text = tx.getText ();
        if (text == null || text.length () < 1)
        {
            sb.append (" ");
            sb.append ("/>");
            return sb.toString ();
        }
        
        sb.append (">");
        sb.append (cxvt (text));
        sb.append ("</");
        sb.append (tag);
        sb.append (">");
        
        return sb.toString ();
    }
    
    /**
     * @param tag Current tag
     * @param tx Current component
     *
     * @return Tag value
     */
    private final String getValueBox (String tag, JComponent tx)
    {
        if ((tx instanceof JComboBox) == false )  return "";
        
        StringBuffer sb = new StringBuffer ();
        sb.append ("<");
        sb.append (tag);
        
        JComboBox bx = (JComboBox)(tx);
        
        String text = (String)bx.getSelectedItem ();
        if (text == null || text.length () < 1)
        {
            sb.append (" ");
            sb.append ("/>");
            return sb.toString ();
        }
        
        sb.append (">");
        sb.append (cxvt (text));
        sb.append ("</");
        sb.append (tag);
        sb.append (">");
        
        return sb.toString ();
    }
    
    /**
     * @param tag Current tag
     * @param tx Current component
     *
     * @return Tag value
     */
    private final String getValueList (String tag, JComponent bx)
    {   
        if (bx instanceof JList == false) return "";
        JList tx = (JList)bx; 
        StringBuffer sb = new StringBuffer ();
        sb.append ("<");
        sb.append (tag);
        
//        System.out.println (tag);    
        Object [] text = tx.getSelectedValues ();
        
        if (text == null || text.length < 1)
        {
            sb.append (" ");
            sb.append ("/>");
            return sb.toString ();
        }
        sb.append (">");
        
        int tlen = text.length;
        for (int i=0; i<tlen; i++)
        {
            sb.append (cxvt ((String)text [i]));
            if (i!=tlen-1)
            {
                sb.append (",");
            }
        }
        
        sb.append ("</");
        sb.append (tag);
        sb.append (">");
        
        return sb.toString ();
    } 
    
    /**
     * @param text Text
     * @return With &amp; &quot; text
     */
    private final String cxvt (String text)
    {
        int tlen = text.length ();
        if (text.indexOf ("&") >= 0 || text.indexOf ("\"") >= 0 ||
            text.indexOf ("\'") >= 0 || text.indexOf ("<") >= 0 ||
            text.indexOf (">") >= 0)
        {
            StringBuffer sb = new StringBuffer ();
            char chr = '*';
            for (int i=0; i<tlen; i++)
            {
                chr = text.charAt (i);
                if (chr == '\"')
                {
                    sb.append ("&quot;");
                    continue;
                }
                
                else if (chr == (char)0x27)
                {
                    sb.append ("&apos;");
                    continue;
                }
                
                else if (chr == '&')
                {
                    sb.append ("&amp;");
                    continue;
                }
                
                else if (chr == '<')
                {
                    sb.append ("&lt;");
                    continue;
                }
                
                else if (chr == '>')
                {
                    sb.append ("&gt;");
                    continue;
                }
                
                else
                {
                    int ch = (int)chr;
                    if (ch >= 252)
                    {
//                        sb.append ("&amp;#");
//                        sb.append (Integer.toString (ch));
//                        sb.append (";");
                    }
                    else sb.append (chr);
                }
            }
            text = sb.toString ();
        }
        String metin = text;
        return metin;
    }
    
    /**
     * @param tag Current tag
     * @param tx Current text component
     *
     * @return Tag value
     */
    private final String getValueX (String tag, JTextComponent tx)
    {
        StringBuffer sb = new StringBuffer ();
        sb.append ("<");
        sb.append (tag);
        
        String text = tx.getText ();
        if (text == null || text.length () < 1)
        {
            sb.append (" ");
            sb.append ("/>");
            return sb.toString ();
        }
        
        sb.append (">");
        String CRLF = "\r\n";
        
        boolean errored = false;
        try
        {
            Reader strr = new StringReader (text);
            BufferedReader br = new BufferedReader (strr);
            String line = null;
            
            while ( (line=br.readLine ()) != null )
            {
                sb.append (cxvt (line));
                sb.append (CRLF);
            }
                
            br.close ();
            strr.close ();
            try
            {}
            finally
            {
                br.close ();
                strr.close ();
            }
        }
        catch (Exception e)
        {
            errored = true;
        }
        
        sb.append ("</");
        sb.append (tag);
        sb.append (">");
        
        return sb.toString ();
    }    
    
    /** Closes br, fr readers*/
    private final void close (Reader br, Reader fr)
    {
        try
        {
            if (br != null) br.close ();
            if (fr != null) fr.close ();
        }
        catch (Exception e)
        {}
        finally
        {
            try
            {
                if (br != null) br.close ();
                if (fr != null) fr.close ();
            }
            catch (Exception e)
            {}
        }
    }
    
    /** Reads xml like a txt file*/
    private final boolean readSingle ()
    {
        boolean error = false;
        try
        {
            int r = jfc.showOpenDialog (mb);
            if (r != JFileChooser.APPROVE_OPTION)
            {
                return true;
            }
            File f = jfc.getSelectedFile ();
            Reader fr = new FileReader (f);
            BufferedReader br = new BufferedReader (fr);
            
            String line = null;
            error = false;
            
            StringBuffer sb = new StringBuffer ();
            
            while ( (line=br.readLine ()) != null && (error==false) )
            {
               sb.append (line);
               sb.append ("\r\n");
            }
            
            reportArea.setText (sb.toString ());
            
            br.close ();
            fr.close ();
            
            return true;
        }
        catch (Exception e)
        {
            error = true;
            return false;
        }
    }
    
    /** Reads Pad*/
    private final void readPAD ()
    {
        try
        {
            if (xmlreader == null)
            {
                JOptionPane.showMessageDialog (mb, 
                   "Your System Has Not A Valid XMLParser!",
                   "XML Error",
                   JOptionPane.ERROR_MESSAGE);
                return;
            }
            int rep = jfc.showOpenDialog (mb);
            if (rep != JFileChooser.APPROVE_OPTION) return;
            
            File f = jfc.getSelectedFile ();
            
            if (f.isDirectory ()) return;
            
            String name = f.getName ().toLowerCase ();
            
            if (name.endsWith (".xml") == false)
            {
                JOptionPane.showMessageDialog (mb, f.getName ()+" has not xml extendsion!");
                return;
            }
            
            for (int i=0; i<componentsLength; i++)
            {
                if (components [i] instanceof JTextComponent)
                    ((JTextComponent)components [i]).setText ("");
            }
            
            int ll = twodimcomp.length;
            int kc = 0;
            JTextComponent [] cmpss = null;
        
            for (int i=0; i<ll; i++)
            {
                cmpss = twodimcomp [i];
                kc = cmpss.length;
                for (int j=1; j<kc; j++)
                {
                    twodimcomp [i][j].setText ("");
                }    
            }
            
            InputStream fis = new FileInputStream (f);
            InputStream bis = new BufferedInputStream (fis);
            InputSource source = new InputSource (bis);
            
            xmlreader.parse (source);
            
            bis.close ();
            fis.close ();
            
            JOptionPane.showMessageDialog (
                mb,
                ("Parsed: "+f.getName ()+" successfully!"),
                "Parsed",
                JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        catch (Exception e)
        {
//            JOptionPane.showMessageDialog (mb,
//                "Error Internal XML!",
//                "Error",
//                JOptionPane.ERROR_MESSAGE);
            e.printStackTrace ();
        }
    }
    
    /** @param evt Action Event object*/
    public void actionPerformed (ActionEvent evt)
    {
        Thread t = new Thread ()
        {
            public void run ()
            {
                readPAD ();
            }
        };
        t.start ();
    }
    
    /**
     * Set LF
     * PS: Java 1.4 & 1.5 has not Nimbus LF. 
     *     WARNING! And maybe you cannot run SAX before 1.5
     *     If you want to see Nimbus LF use 1.6
     */
    static private final void setLF ()
    {
        String javers = System.getProperty ("java.version");
        System.out.println ("Java Version: "+javers+"");
        
        if (javers.compareTo ("1.6") >= 0)
        {
            try
            {
                UIManager.setLookAndFeel (
                    "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
            }
            catch (Exception e)
            {
                e.printStackTrace ();
            }
        }
        else
        {
            try
            {
                UIManager.setLookAndFeel (
                    new javax.swing.plaf.metal.MetalLookAndFeel ());
            }
            catch (Exception e)
            {}
        }
        System.out.println ("LF: "+UIManager.getLookAndFeel ());
    }
    
    /** Shows main screen*/
    static final private void ekran ()
    {
        setLF ();
        
        fr = new JFrame ("Open Source GNU GPL Pad Generator, dilmerkezi.net");
        fr.setDefaultCloseOperation (0x3);//exit on close
        
        JComponent jc = new PadGenerator ();
        jc.setOpaque (true);
        fr.setContentPane (jc);
        
        fr.pack ();
        fr.setSize (600, 525);
        fr.setResizable (false);
        fr.setLocationRelativeTo (null);
        fr.setVisible (true);
    }
    
    /** 
     * Main method. Program starts from here
     *
     * @param args Argument array
     */
    public static final void main (String [] args)
    {
        Runnable r = new Runnable ()
        {
            public void run ()
            {
                ekran ();
            }
        };
        javax.swing.SwingUtilities.invokeLater (r);
    }
    
}
//class end
